#
# Define what kernels to be built
#

%define BUILD_CUSTOM 0
%define BUILD_BOOT 0
# BOOT kernel only can be built for i386 arch

%define BUILD_SECURE_SMP 0
%define BUILD_SECURE_UP 0
# SECURE* kernels now aren't avaiable so don't try to build them

%define BUILD_RSBAC_SMP 0
%define BUILD_RSBAC_UP 0
# RSBAC kernels now aren't avaiable so don't try to build them

%define BUILD_SMP 1
%define BUILD_UP 1
# Normal kernels

%define BUILD_LINUS 0
# LINUS and other kernels can't be built together, so if you defined 
# BUILD_LINUS other kernel defines will be ignored
# Also, default config for this kernel avaiable only in i586-SMP &
# i586-UP variants, so automatically it'll be build only for i586 arch

#
# What kernel-related packages to be built.
#

%define BUILD_HEADERS 1
%define BUILD_SOURCE 0

# Please note that headers & source packages will not be built if you're
# compile custom kernel

%define BUILD_DOCS 1

#
# Custom kernel name
#

# Name of the custom kernel - it's "custom" by default
%define CUSTOM custom

#
# Define what additional drivers to be built
#

%define BUILD_PCMCIACS 0

# Build drm from XFree86 sources
%define BUILD_DRM 0
%define BUILD_DRM_SIS 0
%define BUILD_DRM_GAMMA 0

# Define it to build new alsa drivers (0.9.x)
%define BUILD_ALSA 1

# Define what alsa modules to build (all by default)
%define ALSA_MODULES all

# Define it to build closed-source drivers
%define BUILD_NVIDIA 1

# Define it to build saa7134 philips tuner driver keep in mind that
# v4l 2.0 support will also enabled
%define BUILD_SAA7134 0

# Define it to build hsflinmoded drivers
%define BUILD_HSF 1

# Define it to build slmdm drivers
%define BUILD_SLMDM 1

# Define it to build hpt drivers
%define BUILD_HPT 1

# Define it to build ATI Radeon drivers
# Note that currently it does'nt work
%define BUILD_ATI 1

# Define it to apply rsbac patches. Keep in
# mind that you can compile only custom kernel with this option
%define APPLY_RSBAC 0

#
# Possibly NOT safe optimization and possibly unstable patches and options - Be 
# careful with it
#

#
# Choose the compiler and it's options
#

# If you define this string to 1 kernel will be compiled with 
# gcc-2.95.x, otherwise standart ALT Linux compiler will be used (now 
# it's gcc-2.96). Keep in mind that binary code generated by gcc-2.95.x 
# it smaller, but on new CPU's (such as i686, P-IV and AMD Athlon) it's 
# slower than gcc 2.96
%define USE_GCC_COMPAT 0

# If you have another compiler (such as gcc-3.xx) you can define path 
# to it here. For example you may "define USE_CUSTOM_GCC and define
# CUSTOM_GCC /usr/bin/gcc-3.0.4" to build kernel with gcc3
%define USE_CUSTOM_GCC 1
%define CUSTOM_GCC /usr/bin/gcc-2.96

# Select optimization level for gcc. By default it's 2, but you can 
# choose 3 - it mostly stable. Higher levels are unstable in some code.
%define GCC_OPTIMIZATION 2

%define sublevel 20
%define kversion 2.4.%sublevel

Name: kernel24
Version: %kversion
Release: alt5
Packager: Rider <rider@altlinux.ru>

%define prever 2.4.20
%define nofinal 0
%define KVERREL %kversion-%release
%define ovver 1.61
# From emu10k1 CVS
%define emuver 20030123
# http://dxr3.sourceforge.net/
%define dxr3ver 0.13.0
# ftp://ftp.kernel.org/pub/linux/kernel :-)
%define srcversion 2.4.20
# http://pcmcia-cs.sourceforge.net/
%define pcmciaver 3.2.1
# http://www.linux-vs.org/
%define ipvsver 1.0.7
# http://www.alsa-project.org/
%define alsaver 0.9.0rc7
#%define acpiver 20020329
# http://secure.netroedge.com/~lm78/
%define lmver 2.7.0
%define i2cver 2.7.0
# http://www.freeswan.org/
%define freeswanver 1.99
# http://www.rsbac.org/
%define rsbacver 1.1.2
%define rsbacbugfixver 0
# From XFree86 sources
%define drmver 4.2.1
# http://people.freebsd.org/~gibbs/linux/ - temporary from linux kernel
%define aicver 6.2.5
# http://linuxtv.org/dvb/
%define dvbver 0.9.4
# http://prdownloads.sourceforge.net/sarlib/
%define sarlibver 0.2.4
#%%define jfsver 1.0.21
#ftp://aiedownload.intel.com/df-support/2896/eng/
#%define e100ver 2.1.6
#ftp://aiedownload.intel.com/df-support/2897/eng/
#%define e1000ver 4.3.2
%define bttver 0.8.43
#http://www.garloff.de/kurt/linux/dc395/
%define dc395ver 141
%define qcegaver 20021121
%define susever 2.4.19-40
%define aaver 2.4.21rc3aa1
%define nvver 1.0.4191
%define nfver 1.0-0248
%define nvrealver 1.0-4191
#%define cmpciver 5.68.1LK-SMP
%define x3c90ver 102
%define saa7134ver 0.1.10
#http://www.mbsi.ca/cnxtlindrv/
%define hsflinmodemver 5.03.27mbsibeta02122600
%define hcfpcimodemver 0.99mbsibeta02123100
%define riptidever 0.4mbsibeta02122500
#http://www.smlink.com/
%define slmdmver 2.6.16_i386
%define slmdmversion 2.6.16
%define hptversion v13
%define ativer 2.5.1
%define lircver 0.6.6

Summary: The Linux kernel (the core of the Linux operating system)
License: GPL
Group: System/Kernel and hardware
ExclusiveArch: %ix86
ExclusiveOS: Linux

%if %USE_GCC_COMPAT
BuildRequires: compat-gcc compat-gcc-c++
%else
BuildRequires: gcc2.96 gcc2.96-c++
%endif
BuildRequires: dev86 byacc flex zlib-devel libdb4-devel

###############
### SOURCES ###
###############

Source0: ftp://ftp.kernel.org/pub/linux/kernel/v2.4/linux-%srcversion.tar.bz2


Source1: anonymous@projects.sourceforge.net:/pub/pcmcia-cs/pcmcia-cs-%pcmciaver.tar.bz2
Source4: README.kernel-sources
Source6: ftp://opensource.creative.com/pub/snapshots/emu10k1-%emuver.tar.bz2
Source7: ftp://ftp.alsa-project.org/pub/driver/alsa-driver-%alsaver.tar.bz2


Source9: http://www.lm-sensors.nu/archive/lm_sensors-%lmver.tar.bz2
Source11: http://download.sourceforge.net/LIRC/lirc-%lircver.tar.bz2
Source12: drm-%drmver.tar.bz2

Source13: rhkmvtag.c
Source16: i2c-%i2cver.tar.bz2

Source17: rsbac-v%rsbacver.tar.bz2
Source18: ipvs-%ipvsver.tar.bz2
Source19: freeswan-%freeswanver.tar.bz2

Source20: kernel-%kversion-i586-up.config
Source21: kernel-%kversion-i586-smp.config
Source22: kernel-%kversion-i686-up.config
Source23: kernel-%kversion-i686-smp.config
Source24: kernel-%kversion-athlon-up.config
Source25: kernel-%kversion-athlon-smp.config
Source26: kernel-%kversion-k6-up.config

Source30: kernel-%kversion-i586-up-rsbac.config
Source31: kernel-%kversion-i586-smp-rsbac.config
Source32: kernel-%kversion-i686-up-rsbac.config
Source33: kernel-%kversion-i686-smp-rsbac.config
Source34: kernel-%kversion-athlon-up-rsbac.config
Source35: kernel-%kversion-athlon-smp-rsbac.config
Source36: kernel-%kversion-k6-up-rsbac.config
Source37: kernel-%kversion-i386-boot.config
Source38: kernel-%kversion-i586-linus-up.config
Source39: kernel-%kversion-i586-linus-smp.config

Source41: kernel.xpm
Source42: kernel-source.menu

Source43: linux_logo.h

%if %nofinal
Source44: patch-%kversion.log.bz2
%else
Source44: ChangeLog-%srcversion
%endif

Source45: aa_patches-stable-%aaver.tar.bz2
Source46: suse_patches-stable-%susever.tar.bz2
Source47: kernel-source.changes.bz2

Source50: slmdm-%slmdmver.tar.bz2
Source54: em8300-%dxr3ver.tar.bz2
Source57: bttv-%bttver.tar.bz2
Source60: hsflinmodem-%hsflinmodemver.tar.bz2
Source61: siemens_dvb-%dvbver.tar.bz2
Source63: saa7134-%saa7134ver.tar.bz2
Source65: http://www.alcatel.com/SpeedTouch.tar.bz2
Source66: http://prdownloads.sourceforge.net/sarlib/sarlib-%sarlibver.tar.bz2
Source67: dc395-%dc395ver.tar.bz2
Source68: riptide-%riptidever.tar.bz2
Source69: hcfpcimodem-%hcfpcimodemver.tar.bz2
Source71: linux_logo_lpp.h.bz2
Source72: linux_logo_nolpp.h.bz2
# http://www.webit.at/~twinny/linuxsis630.shtml
Source73: sisfb_src_020902-1.tar.bz2
Source74: definitions
Source75: NVIDIA_nforce-%nfver.tar.bz2
Source77: NVIDIA_kernel-%nvrealver.tar.bz2
%if %BUILD_ATI
# http://www.ati.com/
Source78: build_mod-2.5.1.tar.bz2
%endif
Source81: license.txt
Source82: hpt3xx-opensource-%hptversion.tgz
#http://www.hojdpunkten.ac.se/054/samba/
Source83: smbfs_patches.tar.bz2
Source84: 3c90x-%x3c90ver.tar.bz2

###############
### PATCHES ###
###############

###
# Kernel version updates and generic kernel patches.
# 0..99 #
###

%if %nofinal
Patch0: ftp://ftp.kernel.org/pub/linux/kernel/testing/patch-%prever.bz2
%endif

###
# Architecture specific patches
# 100..599 #
###

###
# Bugfixes to the core system
# and patches related to how RPMs are build
# 600..999
###

# Fix number of arguments may be given to kernel
Patch600: linux-2.4.8-ac7-numargs.patch

# Change kernel errorlevel of apic error message
Patch610: linux-2.4.8-ac3-apic-quiet.patch

# Fix kernel printk's loglevel
Patch620: linux-2.4.19-shutup.patch.bz2

# Fix init call
Patch630: linux-2.2.17-init.ipl.patch

# Fix some major kernel defines
Patch640: linux-2.4.20-stable-server-tuning.patch

# Fix capatibility include file
Patch650: linux-2.4.5-ac15-lcap.patch

# Fix compiler bug in network strip.c
Patch660: linux-2.4.9-ac10-strip.patch

# Fix for quota_1, quota_2 MODULE_LICENSE
Patch670: linux-2.4.20-alt-quota-license.patch

###
# Bugfixes to drivers
# 1000..2999
###

# USEIO in eepro driver
Patch1000: linux-2.4.19-eepro_useio.patch

# iscsi driver update
Patch1020: linux-2.4.10-ac10-iscsi-update.patch.bz2
Patch1021: linux-2.4.19-rc5-scsi_endian_fix.patch
Patch1022: linux-2.4.12-ac3-iscsi_config.patch

# Keyboard silence patch
Patch1030: linux-2.4.3-ac13-keyboardsilence.patch

# Support for isdn olitec cards
Patch1040: linux-2.4.3-isdn-olitec-gazel.patch

# Add alternate airo devices drivers
Patch1050: linux-2.4.19-alternateairo.patch.bz2

# Alcatel Speedtouch patch (Makefile + Config.in)
Patch1060: linux-2.4.20-speedtouch.patch

# Add USBVision
Patch1070: linux-2.4.19-rc1-usbvision.patch.bz2
Patch1071: linux-2.4.19-rc5-usbvision_fix.patch
Patch1072: linux-2.4.5-ac13-usbvision-device-map.patch

# Add support for new agp chips
Patch1080: linux-2.4.19-agp_newchips.patch

# Add support for USS725 usb-storage devices
Patch1090: uss725-0.11-2.4.20-rc2.patch.bz2
Patch1091: seq_data_init-master_slave-uss725.2.patch
# Fix 2.96 compiler bug in uss725.c
Patch1092: linux-2.4.20-alt-uss725-2.96-compilefix.patch

# Devfs fixes

# ide floppy devfs fixes
Patch1100: linux-2.4.19-pre4-ide-floppy-devfs-fix.patch
Patch1101: linux-2.4.17-cpuid-msr-devfs.patch

# Fix i810_audio printk's
Patch1110: linux-2.4.20-i810-printk.patch

# Changed Makefile & Config.in for emu10k1 driver
Patch1120: linux-2.4.20-emu10k1.patch
# Fixes for emu_midi
Patch1121: linux-2.4.9-ac3-emu_midi.patch

# Fix make aic7xxx firmware (libdb)
Patch1141: linux-2.4.20-alt-aic7xx-makefile.patch

# Megaraid driver fixes
Patch1150: megaraid-1.18-volatile_cpurelax.patch
Patch1151: linux-2.4.18-pre4-nodell-megaraid.patch

# Raid5xor
Patch1160: linux-2.4.1-ac4-raid5xor.patch

# Add new SB Vibra16c id
Patch1170: linux-2.4.17-rc1-v16c.patch

# Add new id for Microtech Zio card
Patch1180: linux-2.4.19-usb-storage-zio.patch

# Update for mtd drivers
Patch1190: linux-2.4.17-mtdfix.patch

# Selected patches from Alan kernel patch
Patch1200: linux-2.4.20-selected_ac.patch.bz2

# Fix radeonfb 
Patch1201: linux-2.4.19-radeonfb_shutup.patch
Patch1202: linux-2.4.20-alt-radeonfb_fix.patch
Patch1203: linux-2.4.20-alt-radeonfb_accel.patch

# Fix pdcraid initialization structure
Patch1210: linux-2.4.18-alt1-pdcraid.patch

# Add GUS isapnp id
Patch1220: linux-2.4.17-gus-isapnp.patch

# Add check in loop for detection memory problems
Patch1230: linux-2.4.17-loop-badmem.diff

# Vlan driver patches
Patch1240: linux-2.4.17-eepro100-vlan.patch

# Fix usbvision usb urb_t structures
Patch1250: linux-2.4.20-stable-usb_urb_t.patch

# Remove debug
Patch1251: linux-2.4.5-ac15-kaweth-fix.patch

# Add support for new joystics
Patch1260: linux-2.4.5-ac13-iforce.update.patch

# Add kernel version string to bootlogo
Patch1270: linux-2.4.17-rc2-bootlogo_with_version.patch

# Add another ali chipset to quirk list
Patch1280: linux-2.4.17-rc1-ali_quirks.patch

# Fix via nothbridge bios settings
Patch1290: linux-2.4.7-ac3-viakt133.diff

# Add line1 in sb16 mixer for integrated radiochip
Patch1300: sf16-mixer-1.0-2.2.14.patch

# Add option parameter for idescsi driver
Patch1310: linux-2.4.19-rc3-ide-scsi.patch

# Version update for qla drivers
Patch1320: linux-2.4.20-qla_drivers.patch.bz2
#Patch1321: linux-2.4.19-qla1280_v3.23.10.patch.bz2

# Patch for dmi_scan
Patch1330: linux-2.4.20-dmi_scan.patch

# Some fixes for usbscanner driver
Patch1340: linux-2.4.20-selected-pre.patch.bz2

# Fix includes in fbmem
Patch1350: linux-2.4.18-pre3-fbmem_include.patch

# Fix clock driver for laptops with variable cpu clock
Patch1360: linux-2.4.18-rc2-time_laptop.patch

# Network yellowfin card driver update
Patch1370: linux-2.4.18-rc2-yellowfin.patch

# Add tft pannel detection for radeonfb
Patch1380: linux-2.4.18-pre4-radeon-bios-dfpinfo.patch

# Add new id's to usb storage driver
Patch1390: linux-2.4.20-stable-usbat.patch

# Update iscsi driver
Patch1400: linux-2.4.9-iscsi.patch.bz2

# Fix get_fast_time call
Patch1410: linux-2.4.19-get_fast_time.patch

# Fixed mem= parsing
Patch1420: linux-2.4.20-noless4M.patch

# Added support for BLKGETLASTSECT and BLKSETLASTSECT commands
Patch1430: linux-2.4.15-pre6-blkioctl-sector.patch

# Added align support to raid5
Patch1440: linux-2.4.2-ac28-r5align.patch

# Add ide ATA support for Ali south bridge installed in ATi A3 motherboard
Patch1450: linux-2.4.19-alim15x3_ati.patch

# Fixed Promise RAID detection
Patch1460: linux-2.4.17-ac-pdcraid.patch

# Fixed sym53c8xx scsi driver bugs
Patch1470: linux-2.4.8-ac7-sym53c8xx-fixes.patch

# Fix compile with 2.95.x in dc395x scsi driver
Patch1480: linux-2.4.19-dc395x_gcc295x.patch

# Add support for VSCOM cards in serial & parport drivers
# http://ftp.visionsystems.de/multiio/linux/driver/2.4.xx/
Patch1490: linux-2.4.20-vscom.patch

# Add some useful options to 3c59x driver
Patch1500: linux-2.4.20-3c59x-2.3.patch

# Fix scsi scan devices bug
Patch1510: linux-2.4.2-scsi_scan.patch

# Fix loop cryptoapi bug
Patch1520: linux-2.4.6-ac1-loop_lock.patch

# Fix promise controllers bugs and add support for 202{71,77}
# http://www.promise.com/support/download/
Patch1530: promise-patch-2.4.19.bz2

# Fix slmdm drivers
Patch1540: slmdm-2.6.16_i386-makefile.patch
Patch1541: slmdm-2.6.16_i386-usb_structures.patch

# Fix ATI drivers
Patch1550: build_mod-2.5.1.patch

# Fix hpt driver
Patch1560: linux-2.4.20-hpt_drivers.patch

# Add Leadtek Winfast usb drive support
Patch1570: linux-2.4.20-WinFast_usb.patch

# LIRC patches
Patch1580: linux-2.4.20-lirc.patch
Patch1581: linux-2.4.18-pre3-lirc.patch

# Fix IBM drives on hpt366 driver
Patch1590: linux-2.4.20-ibm_hpt.patch

# Fix PCI bug on toshiba
Patch1600: linux-2.4.20-quirks-toshiba.patch

# Fix BUG on SpeedStream USB 10/100 Ethernet
Patch1610: linux-2.4.21-pre3-usb-bug73300bis.patch

# Support more recent BCM5704 chip revs A1/A2
Patch1620: linux-2.4.21-pre3-more-tg3.patch

# fix USB scanner
Patch1630: linux-2.4.20-alt-usb_scanner_fix.patch

###
# Bugfixes to filesystems and new filesystem patches
# 3000..4999
###

# Fix triple lock
Patch3000: linux-2.4.8-ac7-triplelock.patch

# Fix intermezzo filesystem
Patch3010: linux-2.4.16-intermezzo-compile-fix.patch

# Raw devfs support patch
Patch3020: linux-2.4.16-raw_devfs.patch

# JFS patch (Makefile & Config.in & doc)
#Patch3030: linux-2.4.19-jfs-1.0.21-shared.patch

# Fix options parser in iso9660 filesystem
#Patch3040: linux-2.4.18-iso9660opt.patch

# Fix xfs ACL max entries
Patch3050: linux-2.4.19-xfs-increase-aclmaxentries.patch

# Fix quota messages
Patch3060: linux-2.4.7-quotareturn.patch

# Fix dquot_sync aa bug
Patch3070: linux-2.4.20-dquot_sync_aa_fixes.patch

# Add EVMS
Patch3080: evms-1.2.0-linux-2.4.patch.bz2
Patch3081: evms-linux-2.4.20-common-files.patch.bz2
Patch3082: linux-2.4.19-EVMS-VFS-lock.patch

# Fix ext3 data corruption
Patch3090: linux-2.4.20-ext3_corruption_fix.patch

###
# Network subsystem patches
# 4000..4999
###

# Add Crypto IP Encapsulation
Patch4000: linux-2.4.20-stable-cipe-1.4.5.patch.bz2
Patch4010: linux-2.4.2-ac28-cipefix.patch
Patch4020: linux-2.4.9-ac10-cipe_fix.patch

# Freeswan patches
Patch4100: freeswan-1.93-fix-debug.patch
Patch4101: linux-2.4.15-pre6-ipsec-config-snap.patch
Patch4102: linux-2.4.18-rc1-fix-ipsec-include.patch

# IPVS fixes
Patch4200: linux-2.4.15-pre7-ipvs.patch
Patch4201: linux-2.4.20-rc4-ipvs-ksyms_c.patch

###
# New drivers
# 5000..5999
###

# PCMCIA patches
Patch5000: linux-2.2.18-pcmcia-Configure.ipl.patch
Patch5001: linux-2.2.18-pcmcia-makefile.ipl.patch
Patch5002: linux-2.4.2-pcmcia_aic.patch
Patch5003: pcmcia-cs-3.1.27-ohci_update.patch
Patch5004: linux-2.4.7-ac2-pcmcia.patch
Patch5005: pcmcia-ibmtr_cs-fix.patch
Patch5006: pcmcia-cs-3.1.27-spectrum-2.4t.patch.bz2
Patch5007: pcmcia-cs-3.1.29-8139too_cb.patch.bz2
Patch5008: pcmcia-3.1.29-wvlan_fix.patch
Patch5009: pcmcia-cs-3.1.29-Spectrum24t.patch

# Added driver for sf16fm*2 radio cards
Patch5010: linux-2.4.20-stable-sf16fmx2.patch

# International crypto patch
Patch5020: patch-int-2.4.18.3-alt-stable.bz2
Patch5021: linux-2.4.20-lancrypto.patch.bz2

# Added driver for maxi radio card
Patch5030: linux-2.4.15-pre6-maxi_radio.patch

# Fix Makefile of new drm drivers
#Patch5040: drm-Makefile.patch

# dc395 Makefile & Config.in patch
Patch5050: linux-2.4.17-pre1-dc395.patch

# Support for ATI Gatos interface
#Patch5060: linux-2.4.17-rc1-drm-gatos-latest.patch

# 3c90x drivers
Patch5070: linux-2.4.18-3c90x_makefile.patch

# For the two patches e100 and e1000
#Patch5080: linux-2.4.19-rc5-intelethernet-Makefile.patch

# Alternate Lucent Wavelan wireless support
Patch5090: linux-2.4.10-ac10-pcmcia-wvlan_cs.patch.bz2

# Alsa patches
Patch5100: alsa-driver-0.9.0rc2-serialmidi_fix.patch
Patch5101: linux-2.4.20-alsa-0.9.0rc7-updates_CVS.patch
Patch5102: linux-2.4.20-alsa-0.9.0rc7-MS15_problems.patch
Patch5103: linux-2.4.20-alsa-0.9.0rc7-still_more_fix_MS15_problems.patch
Patch5104: alsa-driver-0.9.0rc7-cvsupdate-cf.patch

# DXR2 patch
#Patch5200: linux-2.4.5-ac13-dxr2.patch

# i2c patch
Patch5300: linux-2.4.20-dmi_scan_export.patch

# DVB patches
Patch5400: linux-2.4.19-rc5-dvb_conf.patch
Patch5401: linux-2.4.19-rc5-dvb_fix.patch

# NVIDIA driver patches
Patch5500: NVIDIA_kernel-1.0-4191-alt-makefile.patch
Patch5501: NVIDIA_nforce-1.0-0248_configure.patch

# V4l2 API
Patch5600: v4l2-api-2.4.19.diff.bz2

# bcm4400 network driver
Patch5610: linux-2.4.20-bcm4400.patch.bz2



###
# Specific kernel patches
# 6000..9999
###

# BOOT kernel patches

Patch6000: linux-2.4.7-ac7-BOOT.patch
Patch6001: linux-2.4.20-config-small.patch

# kernel Makefile patch

Patch6002: linux-2.4.20-Makefile.patch



###
# For stuff that has to come last due to the
# amount of drivers they touch
# 10000...infinity :-)
###

# RSBAC patches
Patch10000: patch-%prever-v%rsbacver.bz2
%if %rsbacbugfixver
Patch10010: rsbac-bugfix-v%rsbacver-%rsbacbugfixver.diff
%endif
Patch10020: rsbac-ruid.patch
Patch10040: rsbac-log.patch
Patch10050: rsbac-fix-namei.patch
Patch10060: linux-2.4.18-rsbac-syscall.patch
Patch10090: rsbac-aci_data_structures.patch

####################
### DESCRIPTIONS ###
####################

### KERNELS and MODULES ###

%description
The kernel package contains the Linux kernel (vmlinuz), the core of your
ALT Linux operating system.  The kernel handles the basic functions
of the operating system:  memory allocation, process allocation, device
input and output, etc.

#
# kernel: linus kernel, framebuffer, SMP
#

%package linus-up
Summary: The Linux kernel (the core of the Linux operating system)
Group: System/Kernel and hardware

Provides: module-info, kernel = %kversion, kernel24-linus = %kversion, kernel24 = %kversion, kernel-linus = %kversion
PreReq: /sbin/installkernel, /usr/sbin/rdev, mkinitrd >= 2.8.4-alt1, modutils >= 2.4.17

%description linus-up
The kernel package contains the Linux kernel (vmlinuz), the core of your
ALT Linux operating system.  The kernel handles the basic functions
of the operating system:  memory allocation, process allocation, device
input and output, etc.

%package linus-smp
Summary: The Linux kernel (the core of the Linux operating system)
Group: System/Kernel and hardware

Provides: module-info, kernel = %kversion, kernel24-linus = %kversion, kernel24 = %kversion, kernel-linus = %kversion
PreReq: /sbin/installkernel, /usr/sbin/rdev, mkinitrd >= 2.8.4-alt1, modutils >= 2.4.17

%description linus-smp
The kernel package contains the Linux kernel (vmlinuz), the core of your
ALT Linux operating system.  The kernel handles the basic functions
of the operating system:  memory allocation, process allocation, device
input and output, etc.

#
# kernel: normal kernel, framebuffer, no SMP, no OpenWall security
#

%package up
Summary: The Linux kernel (the core of the Linux operating system)
Group: System/Kernel and hardware

Provides: module-info, kernel = %kversion, kernel24-up = %kversion, kernel24 = %kversion, kernel-up = %kversion
PreReq: /sbin/installkernel, /usr/sbin/rdev,  modutils >= 2.4.17, mkinitrd >= 2.8.4-alt1

%description up
The kernel package contains the Linux kernel (vmlinuz), the core of your
ALT Linux operating system.  The kernel handles the basic functions
of the operating system:  memory allocation, process allocation, device
input and output, etc.

#
# kernel-smp: Symmetric MultiProcessing kernel
#
%package smp
Summary: The Linux Kernel compiled for SMP machines
Group: System/Kernel and hardware

Provides: module-info, kernel = %kversion, kernel24-smp = %kversion, kernel24 = %kversion, kernel-smp = %kversion
PreReq: /sbin/installkernel, /usr/sbin/rdev, modutils >= 2.4.17, mkinitrd >= 2.8.4-alt1

%description smp
This package includes a SMP version of the Linux %kversion kernel. It is
required only on machines with two or more CPUs, although it should work
fine on single-CPU boxes.

#
# kernel-secure-smp: smp kernel with OpenWall patch
#
%package smp-secure
Summary: The secure version of Linux-Kernel
Group: System/Kernel and hardware
Provides: module-info, kernel = %kversion, kernel24 = %kversion, kernel-smp-secure = %kversion
PreReq: /sbin/installkernel, /usr/sbin/rdev, modutils >= 2.4.17, mkinitrd >= 2.8.4-alt1

%description smp-secure
The Secure-Linux patch adds a few security features to the kernel
which, while not a complete method of protection, will stop most of
the 'cookbook' buffer overflow exploits cold. It also adds the option
of restricting the use of symlinks in +t (temp) directories which
fixes most tmp-race exploits as well. It can also add a little bit
more privacy to the system by restricting access to parts of /proc to
root so that users may not see who else is logged on or what they are
doing.

#
# kernel-secure-up: up kernel with OpenWall patch
#
%package up-secure
Summary: The secure version of Linux-Kernel
Group: System/Kernel and hardware
Provides: module-info, kernel = %kversion, kernel24 = %kversion, kernel-up-secure = %kversion
PreReq: /sbin/installkernel, /usr/sbin/rdev, modutils >= 2.4.17, mkinitrd >= 2.8.4-alt1

%description up-secure
The Secure-Linux patch adds a few security features to the kernel
which, while not a complete method of protection, will stop most of
the 'cookbook' buffer overflow exploits cold. It also adds the option
of restricting the use of symlinks in +t (temp) directories which
fixes most tmp-race exploits as well. It can also add a little bit
more privacy to the system by restricting access to parts of /proc to
root so that users may not see who else is logged on or what they are
doing.

#
# kernel-rsbac-smp: smp kernel with RSBAC patch
#
%package smp-rsbac
Summary: The rsbac version of Linux-Kernel
Group: System/Kernel and hardware
Provides: module-info, kernel = %kversion, kernel24 = %kversion, kernel-smp-rsbac = %kversion
PreReq: /sbin/installkernel, /usr/sbin/rdev, modutils >= 2.4.17, mkinitrd >= 2.8.4-alt1

%description smp-rsbac
RSBAC is a flexible, powerful and fast open source access control
framework for current Linux kernels, which has been in stable
production use for over a year (since version 1.0.9a).

#
# kernel-rsbac-up: up kernel with RSBAC patch
#
%package up-rsbac
Summary: The rsbac version of Linux-Kernel
Group: System/Kernel and hardware
Provides: module-info, kernel = %kversion, kernel24 = %kversion, kernel-up-rsbac = %kversion
PreReq: /sbin/installkernel, /usr/sbin/rdev, modutils >= 2.4.17, mkinitrd >= 2.8.4-alt1

%description up-rsbac
RSBAC is a flexible, powerful and fast open source access control
framework for current Linux kernels, which has been in stable
production use for over a year (since version 1.0.9a).

#
# kernel-boot: kernel for installation
#
%package boot
Summary: The Linux Kernel compiled for linux installation
Group: System/Kernel and hardware
Provides: module-info, kernel = %kversion, kernel24 = %kversion, kernel-boot = %kversion
PreReq: /sbin/installkernel, /usr/sbin/rdev, modutils >= 2.4.17, mkinitrd >= 2.8.4-alt1

%description boot
This package includes an installation version of the Linux %kversion kernel.

#
# kernel, customized by user.
#
%if %BUILD_CUSTOM
%package %CUSTOM
Summary: Custom kernel version %kversion for %CUSTOM box
Group: System/Kernel and hardware
Provides: module-info, kernel = %kversion, kernel24 = %kversion, kernel-%CUSTOM = %kversion
PreReq: /sbin/installkernel, /usr/sbin/rdev, modutils >= 2.4.17, mkinitrd >= 2.8.4-alt1

%description %CUSTOM
This package includes a custom version of the Linux %kversion kernel
designed for %CUSTOM box.

%package -n hsflinmodem_kernel-%CUSTOM
Summary: hsflinmodem kernel modules for Conexant Soft Modems support
Group: System/Kernel and hardware
Version: %{kversion}_%hsflinmodemver
License: Conexant
Requires: kernel24-%CUSTOM = %KVERREL
Provides: hsflinmodem = %hsflinmodemver

%description -n hsflinmodem_kernel-%CUSTOM
hsflinmodem kernel modules for Conexant Soft Modems support.

%package -n slmdm_kernel-%CUSTOM
Summary: Smart Link Soft Modem for Linux
Group: System/Kernel and hardware
Version: %{kversion}_%slmdmver
License: Smart Link
Requires: kernel24-%CUSTOM = %KVERREL
Provides: slmdm_kernel = %slmdmversion

%description -n slmdm_kernel-%CUSTOM
Smart Link Soft Modem for Linux.

%package -n NVIDIA_kernel-%CUSTOM
Summary: NVIDIA kernel module for NVIDIA Architecture support
Group: System/Kernel and hardware
Version: %{kversion}_%nvver
License: nVidia
Requires: kernel24-%CUSTOM = %KVERREL
Provides: NVIDIA_kernel = %nvver

%description -n NVIDIA_kernel-%CUSTOM
NVIDIA kernel module for NVIDIA Architecture support.

%package -n fglrx_kernel-%CUSTOM
Summary: ATI kernel module for ATI graphics accelerators
Group: System/Kernel and hardware
Version: %{kversion}_%ativer
License: ATI Technologies
Requires: kernel24-%CUSTOM = %KVERREL
Provides: ATI_kernel = %ativer

%description -n fglrx_kernel-%CUSTOM
ATI kernel module for ATI graphics accelerators.

%package -n alsa24-%CUSTOM
Summary: Advanced Linux Sound Architecture (ALSA) drivers
Group: System/Kernel and hardware
Version: %{kversion}_%alsaver
Requires: kernel24-%CUSTOM = %KVERREL
Provides: alsa2 = %alsaver
Provides: alsa = %alsaver

%description -n alsa24-%CUSTOM
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package have been compiled for %CUSTOM kernel.
%endif

%package -n fglrx_kernel-up
Summary: ATI kernel module for ATI graphics accelerators
Group: System/Kernel and hardware
Version: %{kversion}_%ativer
License: ATI Technologies
Requires: kernel24-up = %KVERREL
Provides: ATI_kernel = %ativer

%description -n fglrx_kernel-up
ATI kernel module for ATI graphics accelerators.

%package -n fglrx_kernel-smp
Summary: ATI kernel module for ATI graphics accelerators
Group: System/Kernel and hardware
Version: %{kversion}_%ativer
License: ATI Technologies
Requires: kernel24-smp = %KVERREL
Provides: ATI_kernel = %ativer

%description -n fglrx_kernel-smp
ATI kernel module for ATI graphics accelerators.

%package -n hsflinmodem_kernel-up
Summary: hsflinmodem kernel modules for Conexant Soft Modems support
Group: System/Kernel and hardware
Version: %{kversion}_%hsflinmodemver
License: Conexant
Requires: kernel24-up = %KVERREL
Provides: hsflinmodem = %hsflinmodemver

%description -n hsflinmodem_kernel-up
hsflinmodem kernel modules for Conexant Soft Modems support.

%package -n hsflinmodem_kernel-smp
Summary: hsflinmodem kernel modules for Conexant Soft Modems support
Group: System/Kernel and hardware
Version: %{kversion}_%hsflinmodemver
License: Conexant
Requires: kernel24-smp = %KVERREL
Provides: hsflinmodem = %hsflinmodemver

%description -n hsflinmodem_kernel-smp
hsflinmodem kernel modules for Conexant Soft Modems support.

%package -n slmdm_kernel-up
Summary: Smart Link Soft Modem for Linux
Group: System/Kernel and hardware
Version: %{kversion}_%slmdmver
License: Smart Link
Requires: kernel24-up = %KVERREL
Provides: slmdm_kernel = %slmdmversion

%description -n slmdm_kernel-up
Smart Link Soft Modem for Linux.

%package -n slmdm_kernel-smp
Summary: Smart Link Soft Modem for Linux
Group: System/Kernel and hardware
Version: %{kversion}_%slmdmver
License: Smart Link
Requires: kernel24-smp = %KVERREL
Provides: slmdm_kernel = %slmdmversion

%description -n slmdm_kernel-smp
Smart Link Soft Modem for Linux.

%package -n hsflinmodem_kernel-up-rsbac
Summary: hsflinmodem kernel modules for Conexant Soft Modems support
Group: System/Kernel and hardware
Version: %{kversion}_%hsflinmodemver
License: Conexant
Requires: kernel24-up-rsbac = %KVERREL
Provides: hsflinmodem = %hsflinmodemver

%description -n hsflinmodem_kernel-up-rsbac
hsflinmodem kernel modules for Conexant Soft Modems support.

%package -n hsflinmodem_kernel-smp-rsbac
Summary: hsflinmodem kernel modules for Conexant Soft Modems support
Group: System/Kernel and hardware
Version: %{kversion}_%hsflinmodemver
License: Conexant
Requires: kernel24-smp-rsbac = %KVERREL
Provides: hsflinmodem = %hsflinmodemver

%description -n hsflinmodem_kernel-smp-rsbac
hsflinmodem kernel modules for Conexant Soft Modems support.

%package -n NVIDIA_kernel-up
Summary: NVIDIA kernel module for NVIDIA Architecture support
Group: System/Kernel and hardware
Version: %{kversion}_%nvver
License: nVidia
Requires: kernel24-up = %KVERREL
Provides: NVIDIA_kernel = %nvver

%description -n NVIDIA_kernel-up
NVIDIA kernel module for NVIDIA Architecture support.

%package -n NVIDIA_kernel-smp
Summary: NVIDIA kernel module for NVIDIA Architecture support
Group: System/Kernel and hardware
Version: %{kversion}_%nvver
License: nVidia
Requires: kernel24-smp = %KVERREL
Provides: NVIDIA_kernel = %nvver

%description -n NVIDIA_kernel-smp
NVIDIA kernel module for NVIDIA Architecture support.

%package -n NVIDIA_kernel-up-rsbac
Summary: NVIDIA kernel module for NVIDIA Architecture support
Group: System/Kernel and hardware
Version: %{kversion}_%nvver
License: nVidia
Requires: kernel24-up-rsbac = %KVERREL
Provides: NVIDIA_kernel = %nvver

%description -n NVIDIA_kernel-up-rsbac
NVIDIA kernel module for NVIDIA Architecture support.

%package -n NVIDIA_kernel-smp-rsbac
Summary: NVIDIA kernel module for NVIDIA Architecture support
Group: System/Kernel and hardware
Version: %{kversion}_%nvver
License: nVidia
Requires: kernel24-smp-rsbac = %KVERREL
Provides: NVIDIA_kernel = %nvver

%description -n NVIDIA_kernel-smp-rsbac
NVIDIA kernel module for NVIDIA Architecture support.

%package -n alsa24-up
Summary: Advanced Linux Sound Architecture (ALSA) drivers
Group: System/Kernel and hardware
Version: %{kversion}_%alsaver
Requires: kernel24-up = %KVERREL
Provides: alsa = %alsaver
Provides: alsa2 = %alsaver

%description -n alsa24-up
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package have been compiled for default up kernel.

%package -n alsa24-smp
Summary: Advanced Linux Sound Architecture (ALSA) drivers
Group: System/Kernel and hardware
Version: %{kversion}_%alsaver
Requires: kernel24-smp = %KVERREL
Provides: alsa = %alsaver
Provides: alsa2 = %alsaver

%description -n alsa24-smp
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package have been compiled for smp kernel.

%package -n alsa24-smp-secure
Summary: Advanced Linux Sound Architecture (ALSA) drivers
Group: System/Kernel and hardware
Version: %{kversion}_%alsaver
Requires: kernel24-smp-secure = %KVERREL
Provides: alsa = %alsaver
Provides: alsa2 = %alsaver

%description -n alsa24-smp-secure
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package have been compiled for secure smp kernel.

%package -n alsa24-up-secure
Summary: Advanced Linux Sound Architecture (ALSA) drivers
Group: System/Kernel and hardware
Version: %{kversion}_%alsaver
Requires: kernel24-up-secure = %KVERREL
Provides: alsa = %alsaver
Provides: alsa2 = %alsaver

%description -n alsa24-up-secure
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package have been compiled for secure up kernel.

%package -n alsa24-smp-rsbac
Summary: Advanced Linux Sound Architecture (ALSA) drivers
Group: System/Kernel and hardware
Version: %{kversion}_%alsaver
Requires: kernel24-smp-rsbac = %KVERREL
Provides: alsa = %alsaver
Provides: alsa2 = %alsaver

%description -n alsa24-smp-rsbac
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package have been compiled for rsbac smp kernel.

%package -n alsa24-up-rsbac
Summary: Advanced Linux Sound Architecture (ALSA) drivers
Group: System/Kernel and hardware
Version: %{kversion}_%alsaver
Requires: kernel24-up-rsbac = %KVERREL
Provides: alsa = %alsaver
Provides: alsa2 = %alsaver

%description -n alsa24-up-rsbac
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package have been compiled for rsbac up kernel.

### SOURCES, HEADERS, DOCS ###

%package -n kernel24-headers
Summary: Header files for the Linux kernel
Group: Development/Kernel
Requires: kernel-headers-common, initscripts >= 5.49-ipl10mdk
Prefix: %prefix
Obsoletes: kernel-headers
Provides: kernel-headers kernel24-headers-std = %KVERREL
Conflicts: kernel24-headers-linus = %KVERREL kernel24-headers-adv = %KVERREL

%description -n kernel24-headers
Kernel-headers includes the C header files for the Linux kernel.  The
header files define structures and constants that are needed for building
most standard programs.  The header files are also needed for rebuilding
the kernel.

%package -n kernel24-linus-headers
Summary: Header files for the Linux kernel
Group: Development/Kernel
Requires: kernel-headers-common, initscripts >= 5.49-ipl10mdk
Prefix: %prefix
Obsoletes: kernel-headers
Provides: kernel-headers kernel24-headers kernel24-headers-linus = %KVERREL
Conflicts: kernel24-headers-std = %KVERREL kernel24-headers-adv = %KVERREL

%description -n kernel24-linus-headers
Kernel-headers includes the C header files for the Linux kernel.  The
header files define structures and constants that are needed for building
most standard programs.  The header files are also needed for rebuilding
the kernel.

%package source
Summary: The source code for the Linux kernel
Group: Development/Kernel
Requires: glibc-devel, ncurses-devel, make, gcc, dev86, byacc, flex
Provides: kernel-source = %KVERREL
PreReq: kernel-headers = %KVERREL
Obsoletes: alsa-source, kernel-source
AutoReq: no
Prefix: %prefix
Requires: gcc2.96 gcc2.96-c++
Requires: dev86 byacc flex zlib-devel libdb4-devel


%description source
The kernel-source package contains the source code files for the Linux
kernel. These source files are needed to build most C programs, since
they depend on the constants defined in the source code. The source
files can also be used to build a custom kernel that is better tuned to
your particular hardware, if you are so inclined (and you know what you're
doing).

%package -n alsa24-source
Summary: The Advanced Linux Sound Architecture (ALSA) source
Group: Development/Kernel
Version: %{kversion}_%alsaver
Requires: kernel24-source = %KVERREL, glibc-devel, ncurses-devel, make, gcc, dev86
Provides: alsa-source = %alsaver
AutoReq: no
Prefix: %prefix

%description -n alsa24-source
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package is the source of alsa use it to fit your alsa modules to the
kernel.

%package -n drm-source
Summary: Direct Rendering Module (DRM) sources
Group: Development/Kernel
Version: %{kversion}_%drmver
Requires: kernel24-source = %KVERREL, glibc-devel, ncurses-devel, make, gcc, dev86
AutoReq: no
Prefix: %prefix

%description -n drm-source
DRM drivers for 3D rendering in XFree86-4.x.

This package is the source of drm use it to fit your drm modules to the
kernel.

%package -n alsa-driver-headers
Summary: The Advanced Linux Sound Architecture (ALSA) header files
Group: Development/Kernel
Version: %alsaver
AutoReq: no
Prefix: %prefix

%description -n alsa-driver-headers
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This package contains header files of alsa.

%package -n NVIDIA_kernel-source
Summary: NVIDIA kernel module for NVIDIA Architecture support
Group: Development/Kernel
Version: %{kversion}_%nvver
License: nVidia
Requires: kernel24-source = %KVERREL, glibc-devel, ncurses-devel, make, gcc, dev86
AutoReq: no

%description -n NVIDIA_kernel-source
NVIDIA kernel module for NVIDIA Architecture support.

This package contains source of NVIDIA kernel driver.

##########################
# Miscellaneous packages #
##########################

#
# kernel-doc: documentation for the Linux kernel
#
%package doc
Summary: Various documentation bits found in the kernel source
Group: Development/Kernel

%description doc
This package contains documentation files form the kernel source. Various
bits of information about the Linux kernel and the device drivers shipped
with it are documented in these files. You also might want install this
package if you need a reference to the options that can be passed to Linux
kernel modules at load time.

#
# End packages - here begins build stage
#

############
### PREP ###
############

%prep
LC_ALL=C
%if %BUILD_BOOT
# Defines for the BOOT kernel
%define _optlevel s
%define USE_GCC_COMPAT 1
%define USE_CUSTOM_GCC 0
%define optflags_kernel -malign-loops=2 -malign-jumps=2 -malign-functions=2 -mpreferred-stack-boundary=2
%else
# Choose optimization level
%define _optlevel %GCC_OPTIMIZATION
%endif

# We won't debug kernel, do we?
%remove_optflags %optflags_debug

# k6 cannot be SMP.
%ifarch k6
%define BUILD_SMP 0
%define BUILD_SECURE_SMP 0
%define BUILD_RSBAC_SMP 0
%endif

%if %BUILD_CUSTOM
%define BUILD_SOURCE 0
%define BUILD_HEADERS 0
%endif

# Optimization for athlon avaiable only in gcc 2.96 and later gcc's
%ifarch athlon
%define USE_GCC_COMPAT 0
%endif

%if !%USE_CUSTOM_GCC
%if %USE_GCC_COMPAT
if [ -e /usr/bin/kgcc ]; then
%define GCC_PARAM CC=/usr/bin/kgcc
	echo "Using non-standart GCC 2.95.x."
else
	echo "GCC 2.95.x not found. Please install it or use another gcc."
	exit 1
fi
%else
%define GCC_PARAM CC=/usr/bin/gcc
%endif
%else
if [ -e %CUSTOM_GCC ]; then
%define GCC_PARAM CC=%CUSTOM_GCC
	echo "Using non-standart GCC %CUSTOM_GCC."
else
	echo "Defined custom gcc name not found. Please check .spec file."
	exit 1
fi
%endif

### SOURCE ###

%if %BUILD_LINUS
%setup -q -n linux-%srcversion -a45
%else #BUILD_LINUS
%setup -q -n linux-%srcversion -a1 -a6 -a7 -a9 -a11 -a17 -a18 -a19 -a12 -a16 -a45 -a46 -a50 -a54 -a57 -a60 -a61 -a63 -a65 -a66 -a67 -a68 -a69 -a75 -a77 -a83 -a84

# For patches.
ln -nsf pcmcia-cs-%pcmciaver pcmcia
ln -nsf alsa-driver-%alsaver alsa

ln -nsf em8300-%dxr3ver em8300
# Freeswan
ln -snf freeswan-%freeswanver freeswan
ln -snf ../freeswan-%freeswanver/klips/net/ipsec net/
ln -snf ../../../lib net/ipsec/libfreeswan
ln -snf ../../../zlib net/ipsec/
ln -snf ../../../libdes net/ipsec/
ln -snf Makefile.kernel net/ipsec/libfreeswan/Makefile
# DRM
ln -snf drm-%drmver drm

# HSF
ln -snf hsflinmodem-%hsflinmodemver hsflinmodem
ln -snf hcfpcimodem-%hcfpcimodemver hcfpcimodem
ln -snf riptide-%riptidever riptide

# SLMDM
ln -snf slmdm-%slmdmver slmdm

rm -rf pcmcia/{cardmgr,flash,debug-tools,man,etc,doc,PCMCIA-HOWTO}
rm -rf freeswan/{doc,pluto,utils}
%endif #BUILD_LINUS

%if %nofinal
%patch0 -p1

%endif

%if !%BUILD_LINUS

# fix read-only permissions which break build
chmod -R +w pcmcia*

# Apply aa patches
for i in aa_patches/*; do
    cat "$i"|patch -s -p1
done

rm -rf aa_patches

# Apply suse patches
for i in suse_patches/*; do
    cat "$i" |patch -s -p1
done

rm -rf suse_patches

# Crypto ip
%patch4000 -p1
%patch4010 -p1

%patch1000 -p1

mkdir -p configs/
%ifarch %ix86
install -m644 %SOURCE20 configs/
%endif

# PCMCIA
pushd pcmcia-cs-%pcmciaver
# Fix ibmtr_cs compile bug
rm -rf include/linux/ibmtr.h
%patch5000 -p2
%patch5001 -p2
%patch5002 -p2
%patch5003 -p1
%patch5004 -p2
%patch5005 -p1
%patch5006 -p1
%patch5007 -p1
%patch5008 -p1
%patch5009 -p1
popd

%patch4100 -p0
%patch1030 -p1
%patch1040 -p1
%patch1050 -p1

# Add Alcatel SpeedTouch driver & SarLib library
mkdir drivers/usb/sarlib
mkdir Documentation/sarlib
cp sarlib-%sarlibver/*.{c,h} drivers/usb/sarlib
cp sarlib-%sarlibver/{BUGS,ChangeLog,TODO,USAGE,VERSION} Documentation/sarlib
cp SpeedTouch/speedtouch.c drivers/usb
%patch1060 -p1

%patch1070 -p1
%patch1071 -p1

%patch3000 -p1
%patch600 -p1
%patch3010 -p1
%patch610 -p1

# Altlinux patches
%patch1080 -p1
%patch5030 -p1
%patch1100 -p1
%patch620 -p1
%patch630 -p1
%patch640 -p1
%patch5010 -p1
%patch4101 -p1
%patch4102 -p1
%patch670 -p1

# Cryptoapi patches
%patch5020 -p1
%patch5021 -p1

# IPVS patches
# Fix for ksyms patch
# cat ipvs-%ipvsver/linux_kernel_ksyms_c.diff | patch -p1
%patch4201 -p1
cat ipvs-%ipvsver/linux_net_Makefile.diff | patch -p1
cat ipvs-%ipvsver/linux_net_ipv4_Config_in.diff | patch -p1
cat ipvs-%ipvsver/linux_ip_fw_compat_c.diff | patch -p1
cat ipvs-%ipvsver/linux_net_netsyms_c.diff | patch -p1
cp -rp ipvs-%ipvsver/ipvs net/ipv4
mv net/ipv4/ipvs/linux_net_ipv4_ipvs_Makefile net/ipv4/ipvs/Makefile
%patch4200 -p1



#%patch5040 -p1
%patch1150 -p1

# Modify drm drivers
cp -f drm/shared/drm/kernel/* drm

# Add support for 3c90x driver
cp -f 3c90x-%x3c90ver/3c90x.{h,c} drivers/net
# Patch Makefile & Config.in
%patch5070 -p1

%patch3020 -p1
%patch1151 -p1
%patch1160 -p1
%patch5090 -p1
%patch1170 -p1
%patch1180 -p1
%patch1190 -p1
%patch1340 -p1
%patch1200 -p1
%patch1201 -p1
%patch1202 -p1
%patch1203 -p1
%patch1210 -p1
%patch1220 -p1
%patch1230 -p1

pushd  alsa-driver-%alsaver
%patch5100 -p1
popd

pushd  alsa-driver-%alsaver/alsa-kernel
%patch5101 -p1
%patch5102 -p1
%patch5103 -p1
popd
%patch5104

# JFS patches
#%%patch3030 -p1

%patch1141 -p1
%patch1250 -p1

#%patch5200 -p1
%patch650 -p1

%patch1260 -p1
%patch1072 -p1
%patch1251 -p1
%patch1270 -p1

%patch1280 -p1
#%patch3040 -p1
%patch1290 -p1
%patch1300 -p1
%patch1310 -p1
%patch660 -p1
%patch4020 -p1
%patch3050 -p1
%patch1101 -p1
%patch1350 -p1
%patch1360 -p1
%patch1370 -p1
%patch1380 -p1
%patch1390 -p1
%patch1420 -p1
%patch1430 -p1
%patch1440 -p1
%patch1450 -p1
%patch1460 -p1
%patch1470 -p1
%patch1490 -p1
%patch1500 -p1
%patch1510 -p1
%patch1520 -p0
%patch1530 -p1
%patch1540 -p0
%patch1541 -p0
%patch1570 -p1
%patch1330 -p1
%patch1590 -p1
%patch1600 -p1
%patch1610 -p1
%patch1620 -p1
%patch1630 -p1

# USS725
%patch1090 -p1
%patch1091 -p1
%patch1092 -p1

# Apply smbfs patches
for i in smbfs_patches/*; do
    cat "$i"|patch -s -p1
done

# Add small patch
%patch6001 -p1

#cat %SOURCE74 > drivers/video/fbprogress.h

# Add EVMS
%patch3080 -p1
%patch3081 -p1
%patch3082 -p1

# Emu10k1 update.

# Patch Makefiles & Configs'in
%patch1120 -p1

for i in emu10k1; do
find $i -type f |xargs fgrep -l '<emu_wrapper.h>' |
	xargs -r perl -pi -e 's/<(emu_wrapper\.h)>/"$1"/'
find $i -type f |xargs fgrep -l 'ac97_probe_codec' |
	xargs -r perl -pi -e 's/ac97_probe_codec/ac97_probe_codec_emu/g'
find $i -type f |xargs fgrep -l 'ac97_read_proc' |
	xargs -r perl -pi -e 's/ac97_read_proc/ac97_read_proc_emu/g'
mv $i/ac97_codec.c $i/ac97_codec_emu.c

install -p -m644 $i/*.{h,c} drivers/sound/$i
install -p -m644 $i/2.4/*.{h,c} drivers/sound/$i

pushd drivers/sound/$i
# Fix emu-midi
%patch1121 -p4
popd
done

# Bring the Kernel Module Version Tag program
install -m644 %SOURCE13 .

# make sure the kernel has the sublevel we know it has...
perl -p -i -e "s/^SUBLEVEL.*/SUBLEVEL = %sublevel/" Makefile

# I2C patching
cd i2c-%i2cver
perl mkpatch/mkpatch.pl . ../ | patch -d ../ -p1 -E
cd ..
# fix lm_sensors patch
cd lm_sensors-%lmver
perl mkpatch/mkpatch.pl . ../ | patch -d ../ -p1 -E
cd ..

# Fix Makefile
%patch5300 -p1

# Install logo wrapper - it depends on CONFIG_LPP option
#cat %SOURCE43 > include/linux/linux_logo.h
#bzcat %SOURCE71 > include/linux/linux_logo_lpp.h
#bzcat %SOURCE72 > include/linux/linux_logo_nolpp.h

# Install updated QLA SCSI drivers
%patch1320 -p1
# Update
#%patch1321 -p1

#mkdir qla2x00
#bzcat %SOURCE56 |tar x -C qla2x00
#install -p -m644 qla2x00/*.{c,h} drivers/scsi
#install -p -m644 qla2x00/README* drivers/scsi
# Patch the configs
# Apply fix

# Install Siemens DVB driver
make -C DVB/driver KERNEL_LOCATION=`pwd` dvb_firm.h

install -p -m644 DVB/driver/{VES1820.c,VES1893.c,stv0299.c,tda8083.c,dvb_firm.h} drivers/media/video
install -p -m644 DVB/driver/{dmxdev.c,dmxdev.h,dvb.c,dvb.h,dvb_net.c,dvb_net.h} drivers/media/video
install -p -m644 DVB/driver/{dvb_frontend.h,L64781.c,SP8870.c,dvb_demux.c,dvb_demux.h} drivers/media/video
install -p -m644 DVB/driver/{dvb_frontend.c,dvbdev.c,dvbdev.h,dvb_filter.c,dvb_filter.h} drivers/media/video
install -p -m644 DVB/driver/{saa7146.c,saa7146_defs.h,saa7146_core.c} drivers/media/video
install -p -m644 DVB/driver/{saa7146_core.h,saa7146_v4l.c,saa7146_v4l.h} drivers/media/video
cat DVB/driver/tuner.c > drivers/media/video/tuner_dvb.c
cat DVB/driver/tuner.h > drivers/media/video/tuner_dvb.h

mkdir -p include/linux/ost
install -p -m644 DVB/ost/include/ost/*.h include/linux/ost
%patch5400 -p1
# Fix dvb.c
%patch5401 -p1

# Install LIRC files
mkdir -p drivers/lirc
install -p -m644 lirc-%lircver/drivers/lirc_dev/lirc_dev.{h,c} drivers/lirc
install -p -m644 lirc-%lircver/drivers/lirc_gpio/lirc_gpio.c drivers/lirc
install -p -m644 lirc-%lircver/drivers/lirc_i2c/lirc_i2c.c drivers/lirc
install -p -m644 lirc-%lircver/drivers/lirc_serial/lirc_serial.c drivers/lirc
install -p -m644 lirc-%lircver/drivers/lirc_sir/lirc_sir.c drivers/lirc
install -p -m644 lirc-%lircver/drivers/lirc_it87/lirc_it87.{c,h} drivers/lirc
install -p -m644 lirc-%lircver/drivers/lirc_bt829/lirc_bt829.c drivers/lirc
install -p -m644 DVB/driver/lirc/lirc_dvb.c drivers/lirc
install -p -m644 lirc-%lircver/drivers/lirc.h drivers/lirc
%patch1580 -p1
%patch1581 -p1

%if %BUILD_SAA7134
# Add v4l2 api
%patch5600 -p1
%endif

# support for  bcm4400 network driver
%patch5610 -p1

# Fix get_fast_time call
%patch1410 -p1

# Install updated radeon framebuffer driver - disabled. Seems that
# driver included in ac-patch is better
#install -p -m644 radeonfb-0.1.0-ve.1/*.{h,c} drivers/video

# Install updated iSCSI driver
%patch1020 -p1
# Update config
%patch1021 -p1
%patch1022 -p1

# Install dc395 SCSI driver
install -p -m644 dc395/*.{h,c} drivers/scsi
# Update configs
%patch5050 -p1

# Fix compile with gcc 2.95.x
%patch1480 -p1


## Apply jgarzik patches
#for i in jgarzik_patches/*; do
#    patch -s -p1 <"$i"
#done

# Install intelethernet drivers
#install -p -m644 e100-%e100ver/src/e100*.{h,c} drivers/net
#install -p -m644 e1000-%e1000ver/src/e1000*.{h,c} drivers/net
#install -p -m644 e1000-%e1000ver/src/kcompat*.{h,c} drivers/net
# Fix Makefile's
#%patch5080 -p1

%patch3060 -p1
%patch3070 -p1
%patch3090 -p1
%patch1400 -p1

# Install updated i810_audio driver
#bzcat %SOURCE60 > drivers/sound/i810_audio.c
# Remove ugly printk's
%patch1110 -p1

# Install updated sisfb driver
pushd drivers/video/sis
bzcat %SOURCE73 | tar -x
popd
cp -f drivers/video/sis/sisfb.h include/linux

#Fix eepro100 ethernet driver for vlan
%patch1240 -p1

# Add support for new cmpci sound driver
#install -p -m644 cmpci-last/cmpci.c drivers/sound/cmpci.c

# Add support for nVidia kernel drivers
mv NVIDIA_kernel-%nvrealver NVIDIA_kernel
pushd NVIDIA_kernel
chmod 0644 *
%patch5500 -p2
popd
%patch5501 -p1

# Install Hpt driver
mkdir hpt
pushd hpt
    zcat %SOURCE82 |tar -x
popd
# Fix that driver
%patch1560 -p1

%if %BUILD_ATI
# Install ATI drivers
bzcat %SOURCE78|tar -x
%patch1550 -p1
%endif

%if %APPLY_RSBAC
# RSBAC patches
%patch10000 -p1
%if %rsbacbugfixver
%patch10010 -p1
%endif
%patch10020 -p1
%patch10040 -p1
%patch10050 -p1
%patch10060 -p1
%patch10090 -p1
%endif

%else #BUILD_LINUS

# Fix compilation for aic7xxx scsi driver
%patch1141 -p1

# Fix comx compilation
patch -p1 <aa_patches/00_comx-driver-compile-1
%endif #BUILD_LINUS

# get rid of unwanted files
find . -name '*~' -o -name '*.orig'|xargs rm -f

###
### build
###

# ldv: This package requires some magic
%buildmulti

# fakeroot go home!
unset LD_PRELOAD ||:

# define kernel arch.
%ifarch %ix86
%define karch i386
%else
%ifarch sparc64
%define karch %_target_cpu
%else
%define karch %_arch
%endif
%endif

Suffix=
What=

MakeVars()
{
	# Is this a special kernel we want to build?
	if [ -n "$1" ] ; then
		Suffix="-$1"
		What="$1 kernel"
	else
		Suffix=
		What="NORMAL kernel"
	fi
}

BuildKernel() {
	echo "Building config for the $What"

	Config=%_target_cpu$Suffix
	KernelVer=%KVERREL$Suffix

	cp -p $RPM_SOURCE_DIR/kernel-%kversion-$Config.config arch/%karch/defconfig
	rm -f .config
	# make sure SUBLEVEL and EXTRAVERSION say what we want them to say
	perl -pi -e "s/^SUBLEVEL.*/SUBLEVEL = %sublevel/; s/^EXTRAVERSION.*/EXTRAVERSION = -%release$Suffix/" Makefile
	make mrproper
	make oldconfig

	cmp -s .config $RPM_SOURCE_DIR/kernel-%kversion-$Config.config || \
		cp -vf .config $RPM_SOURCE_DIR/kernel-%kversion-$Config.config

	echo "Building dependencies for the $What"

	make %GCC_PARAM dep
	make include/linux/version.h

	echo "Building the $What"

	%make_build %GCC_PARAM bzImage

	if grep -q '^CONFIG_MODULES=y' .config; then
		echo "Building modules for the $What"
		%make_build %GCC_PARAM modules
		find include/linux/modules -size 0 |while read file; do
			echo >"$file"
		done
	fi

	mkdir -p $RPM_BUILD_ROOT/boot
	install -p -m644 System.map $RPM_BUILD_ROOT/boot/System.map-$KernelVer
	install -p -m644 arch/%karch/boot/bzImage $RPM_BUILD_ROOT/boot/vmlinuz-$KernelVer

	if grep -q '^CONFIG_MODULES=y' .config; then
		make INSTALL_MOD_PATH=$RPM_BUILD_ROOT modules_install KERNELRELEASE=$KernelVer
	fi
%if !%BUILD_LINUS
	cc -o rhkmvtag rhkmvtag.c init/version.o
	./rhkmvtag >$RPM_BUILD_ROOT/lib/modules/$KernelVer/.rhkmvtag ||:
	rm -f rhkmvtag
%endif #BUILD_LINUS
	rm -f $RPM_BUILD_ROOT/lib/modules/$KernelVer/build
}

BuildDRM() {
	echo "Building DRM for the $What"
	if grep -q '^CONFIG_DRM=y' .config; then
	pushd drm-%drmver
	    make -f Makefile.linux clean
	    DRM_MODULES=""
	    if grep -q '^CONFIG_DRM_TDFX=m' ../.config; then
		DRM_MODULES="tdfx.o"
	    fi
	    %if %BUILD_DRM_GAMMA
		DRM_MODULES="$DRM_MODULES gamma.o"
	    %endif
	    if grep -q '^CONFIG_DRM_R128=m' ../.config; then
		DRM_MODULES="$DRM_MODULES r128.o"
	    fi
	    if grep -q '^CONFIG_DRM_RADEON=m' ../.config; then
		DRM_MODULES="$DRM_MODULES radeon.o"
	    fi
	    if grep -q '^CONFIG_DRM_I810=m' ../.config; then
		DRM_MODULES="$DRM_MODULES i810.o i830.o"
	    fi
	    if grep -q '^CONFIG_DRM_MGA=m' ../.config; then
		DRM_MODULES="$DRM_MODULES mga.o"
	    fi
	    %if %BUILD_DRM_SIS
		DRM_MODULES="$DRM_MODULES sis.o"
		SIS=1
	    %else
		SIS=
	    %endif
	    %make_build %GCC_PARAM CFLAGS="-I../include $OPT_FLAGS" TREE=../include SIS=$SIS -f Makefile.linux $DRM_MODULES

	    install -p -m644 $DRM_MODULES $RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/kernel/drivers/char/drm
	popd
	else
	    echo "Building DRM for the $What disabled in config"
	fi
}

BuildnVidia() {
	echo "Building nVidia for the $What"
	pushd NVIDIA_kernel
	    make clean
	    make %GCC_PARAM SYSINCLUDE="$RPM_BUILD_DIR/linux-%srcversion/include" IGNORE_CC_MISMATCH=1
	    # NVCFLAGS="$OPT_FLAGS"
	    mkdir -p $RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/nVidia
	    install -p -m644 nvidia.o $RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/nVidia
	popd
	pushd nforce/nvnet
	    make clean
	    make %GCC_PARAM SYSINCLUDE="$RPM_BUILD_DIR/linux-%srcversion/include"
	    # NVCFLAGS="$OPT_FLAGS"
	    install -p -m644 nvnet.o $RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/nVidia
	popd
}

BuildSaa7134() {
	echo "Building saa7134 for the $What"
	make -C saa7134-%saa7134ver clean
	make %GCC_PARAM SUBDIRS=saa7134-%saa7134ver modules
	install -p -m644 saa7134-%saa7134ver/{tuner.o,video-buf.o,saa7134.o,tda9887.o} \
	    $RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/kernel/drivers/media/video
}

BuildATI() {
	echo "Building ATI for the $What"
	pushd build_mod
	    rm -rf *.o
	    rm -rf patch
	    ATI_CFLAGS="$OPT_FLAGS" %GCC_PARAM LINUXINCLUDES="$RPM_BUILD_DIR/linux-%srcversion/include" ./make.sh
	    mkdir -p $RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/ati
	    install -p -m644 fglrx.o $RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/ati
	popd
}

BuildHSF() {
	echo "Building hsflinmodem for the $What"
	
	pushd hsflinmodem-%hsflinmodemver/modules
	    perl -pi -e "s/^KERNELSRC=.*/#KERNELSRC=/" common.mak
	    make %GCC_PARAM KERNELSRC="$RPM_BUILD_DIR/linux-%srcversion" DISTRO_CFLAGS="$OPT_FLAGS" clean
	    make %GCC_PARAM KERNELSRC="$RPM_BUILD_DIR/linux-%srcversion" DISTRO_CFLAGS="$OPT_FLAGS"
	    mkdir -p $RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/conexant
	    install -p -m644 hsf*.o \
		$RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/conexant
	popd
	pushd hcfpcimodem-%hcfpcimodemver/modules
	    perl -pi -e "s/^KERNELSRC=.*/#KERNELSRC=/" common.mak
	    make %GCC_PARAM KERNELSRC="$RPM_BUILD_DIR/linux-%srcversion" DISTRO_CFLAGS="$OPT_FLAGS" clean
	    make %GCC_PARAM KERNELSRC="$RPM_BUILD_DIR/linux-%srcversion" DISTRO_CFLAGS="$OPT_FLAGS"
	    install -p -m644 hcfpci*.o \
		$RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/conexant
	popd
	
# Don't build riptide driver for smp - it does'nt support smp :-(
	if [ `expr "$What" : "smp"` -eq 0 ]; then
	    pushd riptide-%riptidever/modules
		perl -pi -e "s/^KERNELSRC=.*/#KERNELSRC=/" common.mak
		make %GCC_PARAM KERNELSRC="$RPM_BUILD_DIR/linux-%srcversion" DISTRO_CFLAGS="$OPT_FLAGS" clean
		make %GCC_PARAM KERNELSRC="$RPM_BUILD_DIR/linux-%srcversion" DISTRO_CFLAGS="$OPT_FLAGS"
		install -p -m644 {riptideint.o,riptidelow.o,riptidesound.o} \
		    $RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/conexant
	    popd
	fi
}

BuildSLMDM() {
	echo "Building SLMDM driver for the $What"
	pushd slmdm-%slmdmver
	    make %GCC_PARAM SLMDM_OPT_FLAGS="$OPT_FLAGS" KERNEL_INCLUDES=../include clean
	    make %GCC_PARAM SLMDM_OPT_FLAGS="$OPT_FLAGS" KERNEL_INCLUDES=../include
	    mkdir -p $RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/slmdm
	    install -p -m644 {slmdm.o,slfax.o,slamrmo.o,slusb.o} \
		$RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/slmdm
	    mkdir -p $RPM_BUILD_ROOT/%_sysconfdir
	    install -p -m644 country.dat $RPM_BUILD_ROOT/%_sysconfdir
# fix me later ^^^^
	popd
}

BuildHPT() {
	echo "Building HPT driver for the $What"
	if [ `expr "$What" : "smp"` -ne 0 ]; then
	    %define HPT_PARAM "SMP=1"
	    echo "Building with SMP=1."
	elif [ `expr "$What" : "boot"` -ne 0 ]; then
	    %define HPT_PARAM "BOOT=1"
	    echo "Building with BOOT=1."
	else
	    %define HPT_PARAM "UP=1"
	    echo "Building without special options."
	fi
	pushd hpt
	    make %GCC_PARAM KERNELDIR=../ HPT_OPT_FLAGS="$OPT_FLAGS" clean
	    make %GCC_PARAM %HPT_PARAM KERNELDIR=../ HPT_OPT_FLAGS="$OPT_FLAGS"
	    install -p -m644 hpt37x2.o \
		$RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/kernel/drivers/scsi
	popd
}

BuildPCMCIA() {
	echo "Building PCMCIA for the $What"

	pushd pcmcia
		make clean DIRS='$(KDIRS)'
		export FORCED_CONF_SRC=2
		./Configure -n --kernel=$RPM_BUILD_DIR/linux-%srcversion \
			--target=$RPM_BUILD_ROOT \
			--moddir=/lib/modules/%KVERREL$Suffix \
			--srctree \
			--notrust \
			--cardbus \
			--nopnp \
			--sysv --srctree --rcdir=%_sysconfdir/rc.d
		%make_build DIRS='$(KDIRS)' %GCC_PARAM \
			CFLAGS="$RPM_OPT_FLAGS %optflags_notraceback %optflags_kernel -Wstrict-prototypes" all
		mkdir -p $RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/pcmcia
		%make_install install DIRS='$(KDIRS)' PREFIX=$RPM_BUILD_ROOT
		rm -rf $RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/net
		mkdir -p $RPM_BUILD_ROOT%_usrsrc/linux/pcmcia-cs-%pcmciaver/include/pcmcia
		sed -e "s|$RPM_BUILD_DIR/linux-%srcversion|%_usrsrc/linux|;s|$RPM_BUILD_ROOT||;" \
			<include/pcmcia/config.h \
			>$RPM_BUILD_ROOT%_usrsrc/linux/pcmcia-cs-%pcmciaver/include/pcmcia/config.h
	popd
}

BuildAlsa() {
	echo "Building ALSA for the $What"

	pushd alsa-driver-%alsaver
		perl -pi -e 's/^c_opts.*//' Makefile.conf.in
		export %GCC_PARAM
		[ -e Makefile.conf ] && make mrproper

		CFLAGS="$RPM_OPT_FLAGS %optflags_notraceback %optflags_kernel -DLINUX" ./configure \
			--with-kernel=$RPM_BUILD_DIR/linux-%srcversion \
			--with-processor=%_target_cpu --with-smp=auto \
			--with-isapnp --with-sequencer=yes --with-oss=yes \
			--with-cards=%ALSA_MODULES \
			--with-moddir=$RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/alsa
		make c_opts="$RPM_OPT_FLAGS %optflags_notraceback %optflags_kernel -Wstrict-prototypes -DLINUX" all

		mkdir -p $RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/alsa
		install -p -m644 modules/*.o $RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix/alsa
		unset CC
	popd
}

SaveHeaders() {
	echo "Saving headers for the $What"
	mkdir -p $RPM_BUILD_ROOT%_libdir/kernel/%KVERREL$Suffix
	install -p -m644 include/linux/autoconf.h \
		$RPM_BUILD_ROOT%_libdir/kernel/%KVERREL$Suffix/autoconf.h
	install -p -m644 include/linux/version.h \
		$RPM_BUILD_ROOT%_libdir/kernel/%KVERREL$Suffix/version.h
	if [ -e include/linux/modversions.h ]; then
		sed -e "s,linux/modules/,%_libdir/kernel/%KVERREL$Suffix/modules/,g" <include/linux/modversions.h \
			>$RPM_BUILD_ROOT%_libdir/kernel/%KVERREL$Suffix/modversions.h
	fi
	cp -a include/linux/modules $RPM_BUILD_ROOT%_libdir/kernel/%KVERREL$Suffix/modules
	pushd $RPM_BUILD_ROOT%_libdir/kernel/%KVERREL$Suffix
		/usr/bin/h2ph -d . *.h
	popd
}

StripModules() {
	echo "Striping modules for the $What"
	%strip_relocatable -g $RPM_BUILD_ROOT/lib/modules/%KVERREL$Suffix
}

BuildAll () {
	BuildKernel
%if %BUILD_SAA7134
	BuildSaa7134
%endif
%if %BUILD_ATI
	BuildATI
%endif
%if %BUILD_HSF
	BuildHSF
%endif
%if %BUILD_SLMDM
	BuildSLMDM
%endif
%if %BUILD_HPT
	BuildHPT
%endif
%if %BUILD_DRM
	BuildDRM
%endif
%if %BUILD_NVIDIA
	BuildnVidia
%endif
%if %BUILD_PCMCIACS
	BuildPCMCIA
%endif
%if %BUILD_ALSA
	BuildAlsa
%endif
	StripModules
	SaveHeaders
}

BuildSecureSMP () {
	MakeVars smp-secure
%if %BUILD_SECURE_SMP
	BuildAll
%else
	echo "Building $What disabled"
%endif
}

BuildSecureUP () {
	MakeVars up-secure
%if %BUILD_SECURE_UP
	BuildAll
%else
	echo "Building $What disabled"
%endif
}

BuildRsbacSMP () {
	MakeVars smp-rsbac
%if %BUILD_RSBAC_SMP
	BuildAll
%else
	echo "Building $What disabled"
%endif
}

BuildRsbacUP () {
	MakeVars up-rsbac
%if %BUILD_RSBAC_UP
	BuildAll
%else
	echo "Building $What disabled"
%endif
}

BuildSMP () {
	MakeVars smp
%if %BUILD_SMP
	BuildAll
%else
	echo "Building $What disabled"
%endif
}

BuildUp () {
	MakeVars up
%if %BUILD_UP
	BuildAll
%else
	echo "Building $What disabled"
%endif
}

BuildLinusUP () {
	MakeVars linus-up
	BuildKernel
	StripModules
	SaveHeaders
}

BuildLinusSMP () {
	MakeVars linus-smp
	BuildKernel
	StripModules
	SaveHeaders
}

BuildBoot () {
	MakeVars boot
%if %BUILD_BOOT
	patch -p1<$RPM_SOURCE_DIR/linux-2.4.7-ac7-BOOT.patch
	BuildKernel
%if %BUILD_PCMCIACS
	BuildPCMCIA
%endif

	StripModules
	SaveHeaders
%else
	echo "Building $What disabled"
%endif
}

BuildCUSTOM () {
	MakeVars %CUSTOM
%if %BUILD_CUSTOM
	BuildAll
%else
	echo "Building custom $What disabled"
%endif
}

###
# DO it...
###

mkdir -p $RPM_BUILD_ROOT%_usrsrc/kernel/linux-%KVERREL
ln -snf kernel/linux-%KVERREL $RPM_BUILD_ROOT%_usrsrc/linux

%if !%BUILD_LINUS
# Patch CFLAGS in Makefile
%if %BUILD_BOOT
OPT_FLAGS="$RPM_OPT_FLAGS %optflags_notraceback %optflags_kernel -Wstrict-prototypes"
%else
OPT_FLAGS="$RPM_OPT_FLAGS %optflags_notraceback %optflags_kernel -Wstrict-prototypes -fno-strict-aliasing"
%endif
perl -pi -e "s/^HOSTCFLAGS.*/HOSTCFLAGS = $OPT_FLAGS/" Makefile
perl -pi -e "s/^CFLAGS_KERNEL.*/CFLAGS_KERNEL := $OPT_FLAGS/" Makefile
perl -pi -e 's/^CFLAGS :=.*/CFLAGS :=/' Makefile
perl -pi -e 's/-fno-strict-aliasing -fno-common//g' Makefile
perl -pi -e 's/^CFLAGS \+=.*/CFLAGS \+=/' Makefile
perl -pi -e 's|^(include arch/\$\(ARCH\)/Makefile)$|$1\nCFLAGS := \$(CPPFLAGS)|' Makefile
#perl -pi -e 's|^(MODFLAGS \+= -DMODVERSIONS -include \$\(HPATH\)/linux/modversions.h).*|$1 \$(CFLAGS_KERNEL)|' Makefile
# Fix cflags
patch -p1< $RPM_SOURCE_DIR/linux-2.4.20-Makefile.patch


BuildCUSTOM
BuildSecureSMP
BuildSecureUP
BuildRsbacSMP
BuildRsbacUP
BuildSMP
BuildUp
BuildBoot
%else #BUILD_LINUS
BuildLinusUP
BuildLinusSMP
%endif #BUILD_LINUS

###
### install
###
%install
echo "Building all the rest"

# Install config files.
mkdir -p configs
install -p -m644 $RPM_SOURCE_DIR/kernel-%kversion-*.config configs

# Install more driver documentation
for f in `find drivers -type f -name README.\*`; do
	install -p -m644 -D "$f" "Documentation/$f"
done

%if !%BUILD_LINUS
# Install -ac ch-log
cat %SOURCE44 >Documentation/kernel.notes

# Install Suse ch-log
bzcat %SOURCE47 >Documentation/lx_sus24.changes

# Install nVidia license
cat %SOURCE81 >Documentation/nvidia_license.txt

%if %BUILD_ALSA
# Install Alsa documentation.
mkdir -p Documentation/sound/alsa
for f in INSTALL FAQ README doc/SOUNDCARDS WARNING; do
    install -p -m644 "alsa-driver-%alsaver/$f" Documentation/sound/alsa
done

# Install Alsa headers.
mkdir -p $RPM_BUILD_ROOT%_includedir/sound
cp -f alsa-driver-%alsaver/include/*.h \
		$RPM_BUILD_ROOT%_includedir/sound
cp -f alsa-driver-%alsaver/alsa-kernel/include/*.h \
		$RPM_BUILD_ROOT%_includedir/sound
%endif

# Install Emu10k1 documentation
mkdir -p Documentation/sound/emu10k1
rm -rf emu10k1/docs/CVS
install -p -m644 emu10k1/docs/* Documentation/sound/emu10k1
%endif

# /Includes links.
mkdir -p $RPM_BUILD_ROOT%_includedir
ln -snf ../src/linux/include/linux $RPM_BUILD_ROOT%_includedir/linux

# Copy all sources.
mkdir -p $RPM_BUILD_ROOT%_usrsrc/linux
tar cf - . |tar xf - -C $RPM_BUILD_ROOT%_usrsrc/linux
install -p -m644 %SOURCE20 $RPM_BUILD_ROOT%_usrsrc/linux/Documentation

# Come from initscripts.
ln -snf /sbin/installkernel $RPM_BUILD_ROOT%_usrsrc/linux/arch/%karch/boot/install.sh

ln -snf ../src/linux/include/asm $RPM_BUILD_ROOT%_includedir/asm

# Make sure EXTRAVERSION says what we want it to say (in sources).
perl -pi -e "s/^EXTRAVERSION.*/EXTRAVERSION = -%release/" $RPM_BUILD_ROOT%_usrsrc/linux/Makefile

# Use the standard i586 config in source.
%if %BUILD_LINUS
install -p -m644 %SOURCE38 $RPM_BUILD_ROOT%_usrsrc/linux/.config
install -p -m644 %SOURCE38 $RPM_BUILD_ROOT%_usrsrc/linux/arch/%karch/defconfig
%else
install -p -m644 %SOURCE20 $RPM_BUILD_ROOT%_usrsrc/linux/.config
install -p -m644 %SOURCE20 $RPM_BUILD_ROOT%_usrsrc/linux/arch/%karch/defconfig
%endif
mkdir -p $RPM_BUILD_ROOT%_usrsrc/kernel/drivers

%if !%BUILD_LINUS

# Clean up the destination.
make clean -C $RPM_BUILD_ROOT%_usrsrc/linux/pcmcia DIRS='$(KDIRS)'

# Create NVIDIA_kernel-source package
%if %BUILD_NVIDIA
mkdir -p $RPM_BUILD_ROOT%_usrsrc/kernel/drivers/NVIDIA_kernel
mkdir -p $RPM_BUILD_ROOT%_usrsrc/kernel/drivers/NVIDIA_kernel/nforce-%nfver
make clean -C $RPM_BUILD_DIR/linux-%srcversion/NVIDIA_kernel
make clean -C $RPM_BUILD_DIR/linux-%srcversion/nforce/nvnet
install -p -m644  $RPM_BUILD_DIR/linux-%srcversion/NVIDIA_kernel/* \
	$RPM_BUILD_ROOT%_usrsrc/kernel/drivers/NVIDIA_kernel
# Fix permissions
find ./nforce -type f|xargs chmod 0644
cp -a $RPM_BUILD_DIR/linux-%srcversion/nforce/* \
	$RPM_BUILD_ROOT%_usrsrc/kernel/drivers/NVIDIA_kernel/nforce-%nfver
%endif

%if %BUILD_ALSA
make mrproper -C $RPM_BUILD_ROOT%_usrsrc/linux/alsa-driver-%alsaver ||:

[ -d $RPM_BUILD_ROOT%_usrsrc/kernel/drivers/alsa-driver-%alsaver ] ||
	mv $RPM_BUILD_ROOT%_usrsrc/linux/alsa-driver-%alsaver \
		$RPM_BUILD_ROOT%_usrsrc/kernel/drivers
%endif

make -C $RPM_BUILD_ROOT%_usrsrc/linux/drm -f Makefile.linux clean

%if BUILD_DRM
pushd $RPM_BUILD_DIR/linux-%srcversion/drm-%drmver
make -f Makefile.linux clean
popd
[ -d $RPM_BUILD_ROOT%_usrsrc/kernel/drivers/drm-%drmver ] ||
	mv $RPM_BUILD_ROOT%_usrsrc/linux/drm-%drmver \
		$RPM_BUILD_ROOT%_usrsrc/kernel/drivers
%endif
%endif

%if !%BUILD_CUSTOM
make mrproper -C $RPM_BUILD_ROOT%_usrsrc/linux
make oldconfig -C $RPM_BUILD_ROOT%_usrsrc/linux
make symlinks -C $RPM_BUILD_ROOT%_usrsrc/linux
# make include/linux/version.h -C $RPM_BUILD_ROOT%_usrsrc/linux
%endif

# We don't ship dependencies.
find $RPM_BUILD_ROOT%_usrsrc/linux/ -name '.*depend' |xargs -r rm -f

rm -rf $RPM_BUILD_ROOT%_usrsrc/linux/include/linux/modules/*

# Universal headers.
for n in autoconf modversions version; do
	echo "#include </var/run/kernel/$n.h>" >"$RPM_BUILD_ROOT%_usrsrc/linux/include/linux/$n.h"
	chmod 644 "$RPM_BUILD_ROOT%_usrsrc/linux/include/linux/$n.h"
done

# Header subpackage.
mkdir -p $RPM_BUILD_ROOT%_libdir/kernel/%KVERREL/include
%if %BUILD_LINUS
cp -a $RPM_BUILD_ROOT%_usrsrc/kernel/linux-%KVERREL/include/{asm,asm-%karch,asm-generic,linux,net,scsi,video,pcmcia} \
    $RPM_BUILD_ROOT%_libdir/kernel/%KVERREL/include
%else
cp -a $RPM_BUILD_ROOT%_usrsrc/kernel/linux-%KVERREL/include/{asm,asm-%karch,asm-generic,linux,net,scsi,video,pcmcia,rsbac} \
    $RPM_BUILD_ROOT%_libdir/kernel/%KVERREL/include
%endif
%ifarch alpha sparc sparc64
cp -a $RPM_BUILD_ROOT%_usrsrc/kernel/linux-%KVERREL/include/math-emu $RPM_BUILD_ROOT%_libdir/kernel/%KVERREL/include
%endif

# Install menu and icon.
#mkdir -p $RPM_BUILD_ROOT{%_sbindir,%_mandir/man8}
install -p -m644 -D %SOURCE41 $RPM_BUILD_ROOT%_miconsdir/%name.xpm
install -p -m644 -D %SOURCE42 $RPM_BUILD_ROOT%_menudir/%name-source

FindKM()
{
	if [ -n "$1" ] ; then
		Suffix="-$1"
	else
		Suffix=
	fi

	F="km$Suffix.files"

	:>"$F"

	KernelVer=%KVERREL$Suffix

	echo "/boot/vmlinuz-$KernelVer" >>"$F"
	echo "/boot/System.map-$KernelVer" >>"$F"
	echo "%_libdir/kernel/$KernelVer" >>"$F"

	echo "%%dir /lib/modules/$KernelVer" >>"$F"

	find $RPM_BUILD_ROOT/lib/modules/$KernelVer -mindepth 1 -maxdepth 1 \! -type l |
		sed -e "s|$RPM_BUILD_ROOT||g" |
		fgrep -v /lib/modules/$KernelVer/modules. |
		fgrep -v /alsa |
		fgrep -v /slmdm |
		fgrep -v /ati |
		fgrep -v /conexant |
		fgrep -v /nVidia >>"$F"

        echo "%%config(noreplace) /lib/modules/$KernelVer/modules.*" >>"$F"
}

FindAlsa()
{
	if [ -n "$1" ] ; then
		Suffix="-$1"
	else
		Suffix=
	fi
	F="alsa$Suffix.files"

	: >"$F"
	echo "/lib/modules/%KVERREL$Suffix/alsa" >>"$F"
	echo "%%doc Documentation/sound/alsa/*" >>"$F"
}

FindnVidia()
{
	if [ -n "$1" ] ; then
		Suffix="-$1"
	else
		Suffix=
	fi
	F="nVidia$Suffix.files"

	: >"$F"
	echo "/lib/modules/%KVERREL$Suffix/nVidia" >>"$F"
}

FindHSF()
{
	if [ -n "$1" ] ; then
		Suffix="-$1"
	else
		Suffix=
	fi
	F="HSF$Suffix.files"

	: >"$F"
	echo "/lib/modules/%KVERREL$Suffix/conexant" >>"$F"
}

FindSLMDM()
{
	if [ -n "$1" ] ; then
		Suffix="-$1"
	else
		Suffix=
	fi
	F="SLMDM$Suffix.files"

	: >"$F"
	echo "/lib/modules/%KVERREL$Suffix/slmdm" >>"$F"
}

FindATI()
{
	if [ -n "$1" ] ; then
		Suffix="-$1"
	else
		Suffix=
	fi
	F="ATI$Suffix.files"

	: >"$F"
	echo "/lib/modules/%KVERREL$Suffix/ati" >>"$F"
}

%if !%BUILD_LINUS

%if %BUILD_CUSTOM
FindKM %CUSTOM
%if %BUILD_HSF
FindHSF %CUSTOM
%endif
%if %BUILD_ATI
FindATI %CUSTOM
%endif
%if %BUILD_SLMDM
FindSLMDM %CUSTOM
%endif
%if %BUILD_ALSA
FindAlsa %CUSTOM
%endif
%if %BUILD_NVIDIA
FindnVidia %CUSTOM
%endif
%endif

%if %BUILD_BOOT
FindKM boot
%endif

%if %BUILD_SECURE_SMP
FindKM smp-secure
%if %BUILD_ALSA
FindAlsa smp-secure
%endif
%endif

%if %BUILD_SECURE_UP
FindKM up-secure
%if %BUILD_ALSA
FindAlsa up-secure
%endif
%endif

%if %BUILD_RSBAC_SMP
FindKM smp-rsbac
%if %BUILD_ALSA
FindAlsa smp-rsbac
%endif
%if %BUILD_NVIDIA
FindnVidia smp-rsbac
%endif
%endif

%if %BUILD_RSBAC_UP
FindKM up-rsbac
%if %BUILD_ALSA
FindAlsa up-rsbac
%endif
%if %BUILD_NVIDIA
FindnVidia up-rsbac
%endif
%endif

%if %BUILD_SMP
FindKM smp
%if %BUILD_HSF
FindHSF smp
%endif
%if %BUILD_ATI
FindATI smp
%endif
%if %BUILD_SLMDM
FindSLMDM smp
%endif
%if %BUILD_ALSA
FindAlsa smp
%endif
%if %BUILD_NVIDIA
FindnVidia smp
%endif
%endif

%if %BUILD_UP
FindKM up
%if %BUILD_HSF
FindHSF up
%endif
%if %BUILD_ATI
FindATI up
%endif
%if %BUILD_SLMDM
FindSLMDM up
%endif
%if %BUILD_ALSA
FindAlsa up
%endif
%if %BUILD_NVIDIA
FindnVidia up
%endif
%endif

%else #BUILD_LINUS
FindKM linus-up
FindKM linus-smp
%endif #BUILD_LINUS

###
### scripts
###

# Do this for upgrades...in case the old modules get removed we have
# loopback in the kernel so that mkinitrd will work.

%if !%BUILD_LINUS

%if %BUILD_SECURE_SMP
%pre smp-secure
/sbin/modprobe loop &>/dev/null ||:
%preun smp-secure
/sbin/modprobe loop &>/dev/null ||:
%post smp-secure
ln -snf vmlinuz-%KVERREL-smp-secure /boot/vmlinuz-smp-secure
ln -snf initrd-%KVERREL-smp-secure.img /boot/initrd-smp-secure.img
/sbin/installkernel -a -c %KVERREL-stable-smp-secure ||:
[ -f /boot/initrd-smp-secure.img ] || rm -f /boot/initrd-smp-secure.img
%endif

%if %BUILD_SECURE_UP
%pre up-secure
/sbin/modprobe loop &>/dev/null ||:
%preun up-secure
/sbin/modprobe loop &>/dev/null ||:
%post up-secure
ln -snf vmlinuz-%KVERREL-up-secure /boot/vmlinuz-up-secure
ln -snf initrd-%KVERREL-up-secure.img /boot/initrd-up-secure.img
/sbin/installkernel -a -c %KVERREL-up-secure ||:
[ -f /boot/initrd-up-secure.img ] || rm -f /boot/initrd-up-secure.img
%endif

%if %BUILD_RSBAC_SMP
%pre smp-rsbac
/sbin/modprobe loop &>/dev/null ||:
%preun smp-rsbac
/sbin/modprobe loop &>/dev/null ||:
%post smp-rsbac
ln -snf vmlinuz-%KVERREL-smp-rsbac /boot/vmlinuz-smp-rsbac
ln -snf initrd-%KVERREL-smp-rsbac.img /boot/initrd-smp-rsbac.img
/sbin/installkernel -a -c %KVERREL-smp-rsbac ||:
[ -f /boot/initrd-smp-rsbac.img ] || rm -f /boot/initrd-smp-rsbac.img
%endif

%if %BUILD_RSBAC_UP
%pre up-rsbac
/sbin/modprobe loop &>/dev/null ||:
%preun up-rsbac
/sbin/modprobe loop &>/dev/null ||:
%post up-rsbac
ln -snf vmlinuz-%KVERREL-up-rsbac /boot/vmlinuz-up-rsbac
ln -snf initrd-%KVERREL-up-rsbac.img /boot/initrd-up-rsbac.img
/sbin/installkernel -a -c %KVERREL-up-rsbac ||:
[ -f /boot/initrd-up-rsbac.img ] || rm -f /boot/initrd-up-rsbac.img
%endif

%if %BUILD_SMP
%pre smp
/sbin/modprobe loop &>/dev/null ||:
%preun smp
/sbin/modprobe loop &>/dev/null ||:
%post smp
ln -snf vmlinuz-%KVERREL-smp /boot/vmlinuz-smp
ln -snf initrd-%KVERREL-smp.img /boot/initrd-smp.img
/sbin/installkernel -a -c %KVERREL-smp ||:
[ -f /boot/initrd-smp.img ] || rm -f /boot/initrd-smp.img
%endif

%if %BUILD_UP
%pre up
/sbin/modprobe loop &>/dev/null ||:
%preun up
/sbin/modprobe loop &>/dev/null ||:
%post up
ln -snf vmlinuz-%KVERREL-up /boot/vmlinuz-up
ln -snf initrd-%KVERREL-up.img /boot/initrd-up.img
/sbin/installkernel -a -c %KVERREL-up ||:
[ -f /boot/initrd-up.img ] || rm -f /boot/initrd-up.img
%endif

%if %BUILD_BOOT
%pre boot
/sbin/modprobe loop &>/dev/null ||:
%preun boot
/sbin/modprobe loop &>/dev/null ||:
%endif

%if %BUILD_CUSTOM
%pre %CUSTOM
/sbin/modprobe loop &>/dev/null ||:
%preun %CUSTOM
/sbin/modprobe loop &>/dev/null ||:
%post %CUSTOM
/sbin/installkernel -a -c %KVERREL-%CUSTOM ||:
%endif

%if %BUILD_HEADERS
%post -n kernel24-headers
/usr/sbin/update-alternatives --install %_libdir/kernel/include kernel_include %_libdir/kernel/%KVERREL/include 24

%preun -n kernel24-headers
/usr/sbin/update-alternatives --remove kernel_include %_libdir/kernel/%KVERREL/include

%triggerpostun -n kernel24-headers -- kernel24-headers < 2.4.9-alt5
/usr/sbin/update-alternatives --auto kernel_include

%triggerpostun -n kernel24-headers -- kernel22-headers < 2.2.19-alt7
/usr/sbin/update-alternatives --auto kernel_include
%endif

%if %BUILD_SOURCE
%post source
/usr/sbin/update-alternatives --install /usr/src/linux usr_src_linux /usr/src/kernel/linux-%KVERREL 24
%update_menus

%preun source
/usr/sbin/update-alternatives --remove usr_src_linux /usr/src/kernel/linux-%KVERREL

%postun source
%clean_menus

%triggerpostun source -- kernel-headers
/usr/sbin/update-alternatives --install /usr/src/linux usr_src_linux /usr/src/kernel/linux-%KVERREL 24

%triggerpostun source -- kernel24-headers < 2.4.8
/usr/sbin/update-alternatives --install /usr/src/linux usr_src_linux /usr/src/kernel/linux-%KVERREL 24

%triggerpostun source -- kernel-source
/usr/sbin/update-alternatives --install /usr/src/linux usr_src_linux /usr/src/kernel/linux-%KVERREL 24

%triggerpostun source -- kernel24-source < 2.4.8
/usr/sbin/update-alternatives --install /usr/src/linux usr_src_linux /usr/src/kernel/linux-%KVERREL 24

%triggerpostun source -- kernel24-source < 2.4.9-alt5
/usr/sbin/update-alternatives --auto usr_src_linux

%triggerpostun source -- kernel22-source < 2.2.19-alt7
/usr/sbin/update-alternatives --auto usr_src_linux
%endif
	
%post -n alsa24-up
[ -n "$DURING_INSTALL" ] ||
/sbin/depmod -ae -F /boot/System.map-%KVERREL-up -r %KVERREL-up
%postun -n alsa24-up
[ -n "$DURING_INSTALL" ] ||
/sbin/depmod -ae -F /boot/System.map-%KVERREL-up -r %KVERREL-up

%post -n alsa24-smp
[ -n "$DURING_INSTALL" ] ||
/sbin/depmod -ae -F /boot/System.map-%KVERREL-smp -r %KVERREL-smp
%postun -n alsa24-smp
[ -n "$DURING_INSTALL" ] ||
/sbin/depmod -ae -F /boot/System.map-%KVERREL-smp -r %KVERREL-smp

%post -n slmdm_kernel-up
[ -n "$DURING_INSTALL" ] ||
/sbin/depmod -ae -F /boot/System.map-%KVERREL-up -r %KVERREL-up
%postun -n slmdm_kernel-up
[ -n "$DURING_INSTALL" ] ||
/sbin/depmod -ae -F /boot/System.map-%KVERREL-up -r %KVERREL-up

%post -n slmdm_kernel-smp
[ -n "$DURING_INSTALL" ] ||
/sbin/depmod -ae -F /boot/System.map-%KVERREL-smp -r %KVERREL-smp
%postun -n slmdm_kernel-smp
[ -n "$DURING_INSTALL" ] ||
/sbin/depmod -ae -F /boot/System.map-%KVERREL-smp -r %KVERREL-smp

%post -n hsflinmodem_kernel-up
[ -n "$DURING_INSTALL" ] ||
/sbin/depmod -ae -F /boot/System.map-%KVERREL-up -r %KVERREL-up
%postun -n hsflinmodem_kernel-up
[ -n "$DURING_INSTALL" ] ||
/sbin/depmod -ae -F /boot/System.map-%KVERREL-up -r %KVERREL-up

%post -n hsflinmodem_kernel-smp
[ -n "$DURING_INSTALL" ] ||
/sbin/depmod -ae -F /boot/System.map-%KVERREL-smp -r %KVERREL-smp
%postun -n hsflinmodem_kernel-smp
[ -n "$DURING_INSTALL" ] ||
/sbin/depmod -ae -F /boot/System.map-%KVERREL-smp -r %KVERREL-smp

%post -n fglrx_kernel-up
[ -n "$DURING_INSTALL" ] ||
/sbin/depmod -ae -F /boot/System.map-%KVERREL-up -r %KVERREL-up
%postun -n fglrx_kernel-up
[ -n "$DURING_INSTALL" ] ||
/sbin/depmod -ae -F /boot/System.map-%KVERREL-up -r %KVERREL-up

%post -n fglrx_kernel-smp
[ -n "$DURING_INSTALL" ] ||
/sbin/depmod -ae -F /boot/System.map-%KVERREL-smp -r %KVERREL-smp
%postun -n fglrx_kernel-smp
[ -n "$DURING_INSTALL" ] ||
/sbin/depmod -ae -F /boot/System.map-%KVERREL-smp -r %KVERREL-smp

%post -n NVIDIA_kernel-up
[ -n "$DURING_INSTALL" ] ||
/sbin/depmod -ae -F /boot/System.map-%KVERREL-up -r %KVERREL-up
%postun -n NVIDIA_kernel-up
[ -n "$DURING_INSTALL" ] ||
/sbin/depmod -ae -F /boot/System.map-%KVERREL-up -r %KVERREL-up

%post -n NVIDIA_kernel-smp
[ -n "$DURING_INSTALL" ] ||
/sbin/depmod -ae -F /boot/System.map-%KVERREL-smp -r %KVERREL-smp
%postun -n NVIDIA_kernel-smp
[ -n "$DURING_INSTALL" ] ||
/sbin/depmod -ae -F /boot/System.map-%KVERREL-smp -r %KVERREL-smp

%else #BUILD_LINUS

%pre linus-up
/sbin/modprobe loop &>/dev/null ||:
%preun linus-up
/sbin/modprobe loop &>/dev/null ||:
%post linus-up
ln -snf vmlinuz-%KVERREL-linus-up /boot/vmlinuz-linus-up
ln -snf initrd-%KVERREL-linus-up.img /boot/initrd-linus-up.img
/sbin/installkernel -a -c %KVERREL-linus-up ||:
[ -f /boot/initrd-linus-up.img ] || rm -f /boot/initrd-linus-up.img

%pre linus-smp
/sbin/modprobe loop &>/dev/null ||:
%preun linus-smp
/sbin/modprobe loop &>/dev/null ||:
%post linus-smp
ln -snf vmlinuz-%KVERREL-linus-smp /boot/vmlinuz-linus-smp
ln -snf initrd-%KVERREL-linus-smp.img /boot/initrd-linus-smp.img
/sbin/installkernel -a -c %KVERREL-linus-smp ||:
[ -f /boot/initrd-linus-smp.img ] || rm -f /boot/initrd-linus-smp.img

%if %BUILD_HEADERS
%post -n kernel24-linus-headers
/usr/sbin/update-alternatives --install %_libdir/kernel/include kernel_include %_libdir/kernel/%KVERREL/include 24

%preun -n kernel24-linus-headers
/usr/sbin/update-alternatives --remove kernel_include %_libdir/kernel/%KVERREL/include

%triggerpostun -n kernel24-linus-headers -- kernel24-headers < 2.4.9-alt5
/usr/sbin/update-alternatives --auto kernel_include

%triggerpostun -n kernel24-linus-headers -- kernel22-headers < 2.2.19-alt7
/usr/sbin/update-alternatives --auto kernel_include
%endif #BUILD_HEADERS
%endif #BUILD_LINUS

###
### file lists
###

### KERNELS AND MODULES ###

%if !%BUILD_LINUS

### NORMAL KERNEL
%if %BUILD_UP
%files up -f km-up.files
%endif

### SMP KERNEL
%if %BUILD_SMP
%files smp -f km-smp.files
%endif

### SECURE_SMP KERNEL
%if %BUILD_SECURE_SMP
%files smp-secure -f km-smp-secure.files
%endif

### SECURE_UP KERNEL
%if %BUILD_SECURE_UP
%files up-secure -f km-up-secure.files
%endif

### RSBAC_SMP KERNEL
%if %BUILD_RSBAC_SMP
%files smp-rsbac -f km-smp-rsbac.files
%endif

### RSBAC_UP KERNEL
%if %BUILD_RSBAC_UP
%files up-rsbac -f km-up-rsbac.files
%endif

### %CUSTOM KERNEL
%if %BUILD_CUSTOM
%files %CUSTOM -f km-%CUSTOM.files
%endif

### BOOT KERNEL
%if %BUILD_BOOT
%files boot -f km-boot.files
%endif

### ALSA MODULES for kernels
%ifarch %ix86

%if %BUILD_UP
%if %BUILD_HSF
%files -n hsflinmodem_kernel-up -f HSF-up.files
%doc hsflinmodem/LICENSE
%endif
%if %BUILD_ATI
%files -n fglrx_kernel-up -f ATI-up.files
%endif
%if %BUILD_SLMDM
%files -n slmdm_kernel-up -f SLMDM-up.files
%doc slmdm/COPYRIGHT
%config %_sysconfdir/country.dat
%endif
%if %BUILD_ALSA
%files -n alsa24-up -f alsa-up.files
%endif
%if %BUILD_NVIDIA
%files -n NVIDIA_kernel-up -f nVidia-up.files
%doc Documentation/nvidia_license.txt
%endif
%endif

%if %BUILD_SMP
%if %BUILD_HSF
%files -n hsflinmodem_kernel-smp -f HSF-smp.files
%doc hsflinmodem/LICENSE
%endif
%if %BUILD_ATI
%files -n fglrx_kernel-smp -f ATI-smp.files
%endif
%if %BUILD_SLMDM
%files -n slmdm_kernel-smp -f SLMDM-smp.files
%doc slmdm/COPYRIGHT
%config %_sysconfdir/country.dat
%endif
%if %BUILD_ALSA
%files -n alsa24-smp -f alsa-smp.files
%endif
%if %BUILD_NVIDIA
%files -n NVIDIA_kernel-smp -f nVidia-smp.files
%doc Documentation/nvidia_license.txt
%endif
%endif

%if %BUILD_SECURE_SMP
%if %BUILD_ALSA
%files -n alsa24-smp-secure -f alsa-smp-secure.files
%endif
%if %BUILD_NVIDIA
%files -n NVIDIA_kernel-smp-secure -f nVidia-smp-secure.files
%doc Documentation/nvidia_license.txt
%endif
%endif

%if %BUILD_SECURE_UP
%if %BUILD_ALSA
%files -n alsa24-up-secure -f alsa-up-secure.files
%endif
%if %BUILD_NVIDIA
%files -n NVIDIA_kernel-up-secure -f nVidia-up-secure.files
%doc Documentation/nvidia_license.txt
%endif
%endif

%if %BUILD_RSBAC_SMP
%if %BUILD_ALSA
%files -n alsa24-smp-rsbac -f alsa-smp-rsbac.files
%endif
%if %BUILD_NVIDIA
%files -n NVIDIA_kernel-smp-rsbac -f nVidia-smp-rsbac.files
%doc Documentation/nvidia_license.txt
%endif
%endif

%if %BUILD_RSBAC_UP
%if %BUILD_ALSA
%files -n alsa24-up-rsbac -f alsa-up-rsbac.files
%endif
%if %BUILD_NVIDIA
%files -n NVIDIA_kernel-up-rsbac -f nVidia-up-rsbac.files
%doc Documentation/nvidia_license.txt
%endif
%endif

%if %BUILD_CUSTOM
%if %BUILD_HSF
%files -n hsflinmodem_kernel-%CUSTOM -f HSF-%CUSTOM.files
%doc hsflinmodem/LICENSE
%endif
%if %BUILD_ATI
%files -n fglrx_kernel-%CUSTOM -f ATI-%CUSTOM.files
%endif
%if %BUILD_SLMDM
%files -n slmdm_kernel-%CUSTOM -f SLMDM-%CUSTOM.files
%doc slmdm/COPYRIGHT
%config %_sysconfdir/country.dat
%endif
%if %BUILD_NVIDIA
%files -n NVIDIA_kernel-%CUSTOM -f nVidia-%CUSTOM.files
%doc Documentation/nvidia_license.txt
%endif
%if %BUILD_ALSA
%files -n alsa24-%CUSTOM -f alsa-%CUSTOM.files
%endif
%endif

%endif

### SOURCE, HEADERS AND DOCS ###

### KERNEL HEADERS
%if %BUILD_HEADERS
%files -n kernel24-headers
%_libdir/kernel/%KVERREL
%endif

### KERNEL SOURCE
%if %BUILD_SOURCE
%files source
%_menudir/*
%_miconsdir/*.xpm
%_usrsrc/kernel/linux-%KVERREL/COPYING
%_usrsrc/kernel/linux-%KVERREL/CREDITS
%_usrsrc/kernel/linux-%KVERREL/Documentation
%_usrsrc/kernel/linux-%KVERREL/MAINTAINERS
%_usrsrc/kernel/linux-%KVERREL/Makefile
%_usrsrc/kernel/linux-%KVERREL/README
%_usrsrc/kernel/linux-%KVERREL/REPORTING-BUGS
%_usrsrc/kernel/linux-%KVERREL/Rules.make
%_usrsrc/kernel/linux-%KVERREL/rhkmvtag.c
%_usrsrc/kernel/linux-%KVERREL/configs
%_usrsrc/kernel/linux-%KVERREL/crypto
%_usrsrc/kernel/linux-%KVERREL/drivers
%_usrsrc/kernel/linux-%KVERREL/fs
%_usrsrc/kernel/linux-%KVERREL/init
%_usrsrc/kernel/linux-%KVERREL/ipc
%_usrsrc/kernel/linux-%KVERREL/kernel
%_usrsrc/kernel/linux-%KVERREL/lib
%_usrsrc/kernel/linux-%KVERREL/mm
#%_usrsrc/kernel/linux-%KVERREL/modules
%_usrsrc/kernel/linux-%KVERREL/net
%_usrsrc/kernel/linux-%KVERREL/rsbac
%_usrsrc/kernel/linux-%KVERREL/scripts
#%_usrsrc/kernel/linux-%KVERREL/security
%dir %_usrsrc/kernel/linux-%KVERREL/arch
%_usrsrc/kernel/linux-%KVERREL/arch/%karch
%_usrsrc/kernel/linux-%KVERREL/pcmcia*
%_usrsrc/kernel/linux-%KVERREL/freeswan*
%_usrsrc/kernel/linux-%KVERREL/include

### ALSA DRIVER SOURCE
%if %BUILD_ALSA
%files -n alsa24-source
%_usrsrc/kernel/drivers/alsa-driver-%alsaver
%endif

### DRM DRIVER SOURCE
%if %BUILD_DRM
%files -n drm-source
%_usrsrc/kernel/drivers/drm-%drmver
%endif

%if %BUILD_NVIDIA
### NVIDIA DRIVER SOURCE
%files -n NVIDIA_kernel-source
%_usrsrc/kernel/drivers/NVIDIA_kernel
%doc Documentation/nvidia_license.txt
%endif
%endif

%if %BUILD_ALSA
%files -n alsa-driver-headers
%_includedir/sound
%endif

### KERNEL DOCS
%if %BUILD_DOCS
%files doc
#%ifarch %ix86
#%_mandir/man9/*
#%endif
%doc Documentation/*
%endif

%else #BUILD_LINUS
%files linus-up -f km-linus-up.files
%files linus-smp -f km-linus-smp.files
%if %BUILD_HEADERS
%files -n kernel24-linus-headers
%_libdir/kernel/%KVERREL
%endif #BUILD_HEADERS
%endif #BUILD_LINUS

%changelog
* Sun Feb 16 2003 Rider <rider@altlinux.ru> 2.4.20-alt5
- qla1280 fix for ISP 12160 bugs (by Mouse)
- update ALSA from CVS for fix all VIA82xx problems

* Thu Feb 13 2003 Rider <rider@altlinux.ru> 2.4.20-alt4
- removed vma-file-merge-1 patch from aa_patches
- sync kernel-linus configs with kernel24
- fix spec for build kernel-linus
- enable CONFIG_USB_LONG_TIMEOUT for up and smp kernels
- enable CONFIG_APM_REAL_MODE_POWER_OFF for up and smp kernels


* Sun Feb 09 2003 Rider <rider@altlinux.ru> 2.4.20-alt3
- added Makefile.path (#0002190)
- file /etc/country.dat added to slmdm package (#0002189)
- added provides for all alsa24-* packages: alsa2 = alsa_version
- included bcm4400 network driver (#0002212), by Sergey Vlasov
- added MODULE_LICENSE for quota_v1, quota_v2 (#0002211)
- fix for usb scanner bugs (#0002209), by Sergey Vlasov

* Thu Feb 06 2003 Rider <rider@altlinux.ru> 2.4.20-alt2
- build by gcc 2.96
- Fix PCI header on toshiba (RH)
- Fix bug on SpeedStream USB 10/100 Ethernet (RH)
- Support more recent BCM5704 chip revs A1/A2 (RH)
- compile appletalk protocol support as a module (#0002165)


* Mon Feb 03 2003 Rider <rider@altlinux.ru> 2.4.20-alt1
- BuildRequires fix (thanks to LDV)
- update alsa-drivers to 0.9.0-rc7

* Tue Jan 28 2003 Konstantin Volckov <goldhead@altlinux.ru> 2.4.20-alt0.9
- Fixed
  + Now we boots only if mem= parameter >= 4M.
    In other case mem= parameter ignored.
  + Requires to mkinitrd
  + Support for ATA4 & ATA5 modes for IBM drives on hpt366 controller
  + RadeonFB driver (Thanx to Sergey Vlasov)
- Added
  + Splitted linus kernel to -up & -smp
  + Building kernel24-linus-headers
  + New provides/conflicts for kernel24-headers
  + Support for VSCOM cards
  + LIRC drivers 0.6.6
  + Scripts for automatic run depmod on kernel packages (such as alsa24)
  + Selected changes from 2.4.21pre
  + Support for USS725 usb devices
  + Support Appletalk protocol in configs
  + splash screen patch from SuSE
- Removed
  + Hack for Intel SCB2 motherboard - not it's supported
  + fbprogress patch
- Updated
  + HSF modem drivers
  + aa_patches (added some fixes)
  + Selected Alan Cox patches
  + emu10k1 driver

* Tue Dec 24 2002 Konstantin Volckov <goldhead@altlinux.ru> 2.4.20-alt0.8
- Fixed
  + hpt raid driver build (Thanx to Michael Shigorin <mike@osdn.org.ua>)
  + Buildrequires (Thanx to Michael Shigorin <mike@osdn.org.ua>)
  + Building NVIDIA_kernel driver (Thanx to Michael Shigorin <mike@osdn.org.ua>)
  + Now we does'nt booting on Intel SCB2 motherboards due to errors
- Updated
  + Suse patches

* Wed Dec 18 2002 Konstantin Volckov <goldhead@altlinux.ru> 2.4.20-alt0.7
- Added
  + Support for building ATI Radeon drivers
- Fixed
  + Linus kernel build
  + Serverworks ide driver
- Updated
  + lm_sensors & i2c to 2.7.0
  + NVIDIA graphic drivers

* Mon Dec 16 2002 Konstantin Volckov <goldhead@altlinux.ru> 2.4.20-alt0.6
- Fixed
  + Standart kernel file lists
- Added
  + Support for Leadtek WinFast usb drive
- Removed
  + PCTel modem drivers - doesn't work

* Mon Dec 09 2002 Konstantin Volckov <goldhead@altlinux.ru> 2.4.20-alt0.5
- Changes
  + Build boot kernel
  + Rebuild with up & smp kernels
- Added
  + Building hpt raid ide driver
  + Don't build riptide modem driver when SMP.
    It does'nt support it
- Fixed
  + Refixed ext3 bug
  + CSB5 south bridge bug
  + SMP building

* Mon Dec 02 2002 Konstantin Volckov <goldhead@altlinux.ru> 2.4.20-alt0.4
- Changes
  + Build again with gcc 3.2.1
- Added
  + Selected patches from Alan Cox patch set
  + building hcfpcimodem drivers for Conexant devices
  + building riptide* drivers for Conexant devices
  + building slmdm soft modem drivers
  + building pctel softmodem drivers
- Fixed
  + boot config
  + ext3 bug
  + bug in aa_patches
  + Moved conexant modem drivers to conexant directory
  + clean target in makefile
- Updated
  + nVidia nForce drivers to 1.0-0248
  + aa_patches to 2.4.20aa1
  + Promise driver
  + Some spec optimization

* Fri Nov 29 2002 Konstantin Volckov <goldhead@altlinux.ru> 2.4.20-alt0.3
- Moved to 2.4.20 final
- Experimental build with gcc 2.96
- Added lancrypto ciphers

* Wed Nov 27 2002 Konstantin Volckov <goldhead@altlinux.ru> 2.4.20-alt0.2
- Added
  + CONFIG_TMPFS option
  + Some patches from ab
- Updated
  + aa_patches
  + kernel to 2.4.20-rc4

* Tue Nov 19 2002 Konstantin Volckov <goldhead@altlinux.ru> 2.4.20-alt0.1
- Updated
  + kernel to 2.4.20-rc2
  + aa & suse patches
  + alsa drivers to 0.9.0rc6
  + emu10k1
  + Freeswan to 1.99
  + DXR3 to 0.13.0
  + nVidia nForce drivers to 1.0-0246
  + hsflinmodem drivers to 02110301
  + IPVS to 1.0.7

* Tue Oct 10 2002 Konstantin Volckov <goldhead@altlinux.ru> 2.4.19-alt0.8
- Temporary removed gamma.o driver
- Rebuilded for Sisyphus
- Added Sisyphus graphics
- Removed saa7134 & v4l2.0
- Fixed
  + dmaonlydisk patch

* Thu Oct 08 2002 Konstantin Volckov <goldhead@altlinux.ru> 2.4.19-alt0.8manli
- Added AGP support for VIA KT400
- Fixed -boot kernel build

* Thu Oct 03 2002 Konstantin Volckov <goldhead@altlinux.ru> 2.4.19-alt0.7manli
- Added support more memory in not HIGHMEM configuration
- Added DMA support for IDE in i845
- Added build saa7134 drivers
- Added DMA support for ATI M3 ali south bridge
- Fixed Promise RAID standalone drives detection
- Added support for hsflinmodem

* Wed Oct 02 2002 Konstantin Volckov <goldhead@altlinux.ru> 2.4.19-alt0.6manli
- Added manli graphics

* Fri Sep 20 2002 Konstantin Volckov <goldhead@altlinux.ru> 2.4.19-alt0.6
- Fixed
  + drm modules
  + Makefile for aicasm
- Features
  + This kernel now renamed to -up, -smp etc. Previous -up, -smp kernel
    will be renamed too.
- Updated
  + pcmcia_cs to 3.2.1
  + alsa driver to 0.9.0rc3
  + lm_sensors & i2c to 2.6.5
  + Freeswan to 1.98b
- Removed
  + drx2 modules

* Tue Sep 10 2002 Konstantin Volckov <goldhead@altlinux.ru> 2.4.19-alt0.5
- Features
  + Builded by gcc3_2
  + Now by default ide dma enabled only for disks
    to enable dma for other ide devices add string ide=nodmaonlydisk
    to kernel parameters. This option is useful because many ide cd's
    can't properly work with dma.
- Added
  + Version of aa_patches
- Fixed
  + i810_audio module (removed source60)
  + NVIDIA cflags
  + Radeonfb driver
  + Mgafb driver
  + Fixed buildrequires
- Removed
  + jgarzik patches
  + Some aa_patches
- Updated
  + DRM modules compiled from XFree86-4.2.1
  + NVIDIA drivers - video - 1.0-3123, nforce - 1.0-0241
  + sisfb driver
  + VIA ide driver - now we support VIA8235 South bridge
  + JFS version to 1.0.21

* Fri Aug 30 2002 Konstantin Volckov <goldhead@altlinux.ru> 2.4.19-alt0.4
- Fixed
  + BUILD_LINUS kernel.
  + .congig names
  + Added linux-2.4.15-pre6-Makefile.patch to the sources.

* Wed Aug 28 2002 Konstantin Volckov <goldhead@altlinux.ru> 2.4.19-alt0.3
- Feature
  + .spec file rewrited
  + Revision of patches
  + Removed building kernel-source by default
  + Fixed requires to modutils & mkinitrd
- Removed
  + oldalsa
